306

 Installation & Updates
> Error message oleacc.dll not found
> Installer or Binary?
> How can I keep my settings / downloads when updating to a new eMule version?
> Upgrading from eDonkey / Overnet to eMule and keeping downloads
Which influence does the operating system have?
eMule works with all Windows versions after Windows 95. A p2p application uses many network connection thus needs a stable network implementation. Windows 98 and ME have a very poor network implementation impairing eMule's performance. More recent operating systems like Windows 2000 or XP are better suited.
Do not use the registry patches for Windows 98 which promise to raise the possible connections. They do not work properly and may make your system instable.
Top
Error message oleacc.dll not found
This error message may appear when starting eMule on a Windows 98 machine. The missing dll is in Microsoft's Windows 98 System Update.
Top
Installer or Binary?
The installer version is well suited for a first time eMule install as it contains all necessary files and the documentation. Just start the exe and the installer will lead you through the process.
The binary distribution is an archive. The content of the archive has to de extracted to the desired directory. Useful for a version update.
Top
How can I keep my settings / downloads when updating to a new eMule version?
Extract or install a new eMule version to the same directory you use for the old version. Only the eMule.exe and non user files will be replaced. All settings and downloads are kept.
eMule has to be closed before updating to a new version! To keep already existing settings simply hit Cancel when the wizard pops up.
Top

Upgrading from eDonkey / Overnet to eMule and keeping downloads
eDonkey versions prior .47 use an eMule compatible part system whereas versions post .47 split the temporary downloads to many individual files.
For the old version of eDonkey simply point eMule's folder for temporary files to the same one that has been used in eDonkey. Or move the partfiles to your eMule temp-folder when eMule is not running.
Newer versions of eDonkey and Overnet use the split part-system. An "old style" option is available in those clients, which just makes the temporary download to be a single file - the part.met file is still in a new and incompatible format.
eMule v0.30c introduced a convert function to import external partfiles to your eMule downloads. It imports the old fashioned format (eMule, eDonkey <=.47) as well as the split format and the "old style"-format of >.47 eDonkey/Overnet clients. The non-eMule formats will be converted to the eMule format.
You can access the import function from the Hotmenu (press Alt+X) or from the Tools icon. All you need to do there is to specify a folder containing the partfiles. eMule will try to convert the partfiles automatically and add them to your downloads on runtime.
Top

Updated on: 2003-02-27 by Monk

02.05.2004 15:15


308

 Server, Connection & ID
> Where to get a server list?
> Which server is the best the fastest?
> How often do I have to update the server list?
> Why does eMule not connect?
> Why do I get a low ID?
> eMule always disconnects from the server
How to connect to Kademlia?
eMule automatically tries to enter the Kademlia network booting from any compatible client it finds. If it cannot connect simply chose Bootstrap -> From known clients in the Kademlia main windows then connect to a server and start a download. Kademlia will connect shortly after.
Top
Where to get a server list?
http://ed2k.has.it – Just click on Add to eMule.
Top
Which server is the best the fastest?
There is no fastest or best server. They are used to connect to the network and to search for files and sources. eMule asks every server on its list and using Global Search all of them are asked for search results.
Also eMule exchanges sources with other eMule clients and thus finds sources a lot faster this way.
Top
How often do I have to update the server list?
During sessions or if you use eMule regularly there is no need to update the server list as eMule's default settings (Preferences -> Servers -> Update serverlist when connecting to a server and -> Update serverlist when a client connects)will take care that it stays updated.
Top
Why does eMule not connect?
It may take a while until eMule is connected as servers may be down or not responding. If eMule will not connect at all make sure that you have a recent server list and check if any software like firewalls, routers, dial in software is blocking eMule's traffic.
You may also check Preferences -> Server -> Autoconnect to static servers only. If it is checked and you do not provide a staticservers.dat with valid servers eMule will not connect.
Top
Why do I get a low ID?
eMule will only work fully if following ports are open for connection
• 4662 TCP (Server low ID)
• 4672 UDP (Kademlia firewalled)
• 4711 TCP (no Webinterface accessible)
There are several reason why these ports may be blocked:
• Firewalls - also the built in of Windows XP. (WinXP SP2 enables it by default!)
• Routers
• Dail-In software of some ISPs
• Connection sharing software / Software routers
• Networks with any form of NATed connection
• Ports blockes by the Internet Service Provider
Check your used software and hardware for any firewall or routing functions and configure it properly to allow incoming connections to the mentioned ports. Also you can try to use different clients ports like 6666, 80 or 20.
More information in the chapters on Firewalls and Routers.
Top
eMule always disconnects from the server
There are some reasons why eMule could disconnect from a server:
• Too many files in the downloads list (only eMule prior v.30a)
• Too many shared files (only eMule prior v.29a)
• Server problem
• general network problem
eMule usually reconnects on loss of the server connection. This is no critical event.
Top

Updated on: 2003-09-03 by Monk

02.05.2004 15:33


309

 Settings & Speed
> Things that influences download
> Which settings are the best?
> How can I increase my download speed?
> Which download rates may I expect?
> How large should the queue be?
Can I turn on eMule, add the latest home video and watch it 5 minutes later?
No, surely not. As eMule is especially used for large files the network is at 100% load nearly all the time. There is a simple rule saying "The sum of all uploads in the network = the sum of all download". Large files need a lot of upload traffic and considering the average low upload rates of today's service providers, it is just natural that the downloads take their time.
eMule is a network about sharing files and not trading them. If you mind the difference eMule is the app for you.
Top
Things that influences download
Some factors that influences the download speed:
• eMules settings
• High ID (Firewall and router settings)
• Duration of the eMule session
• Number of sources for a download
• Availability of single parts
• Popularity of the download
Wrong settings in eMule (wrong limits, too many connections), a low ID and a short sessions durations have a bad impact on download speed. Very popular files (new releases) and generally files with a low number of sources or bad part spreading also cause low download rates.
Top

Which settings are the best?
There are no best settings for eMule as it heavily depends on the type and speed of internet connection and the operating system you use. You always should use the Wizard get good basic settings. Most important is that you provide the correct values for your internet connection and operating system.

Good settings for the widely spread DSL 512 / 128 would be

Windows XP
 | Download capacity: 64 (= 512 / 8)
 | Upload capacity: 16 (= 128 / 8)
 | Download limit: none (remove the check mark)
 | Upload limit: 12
 | Hard Limit: 500
 | Max connections: 400
 | Max new connections / 5 sec: 30
 | Download about 6 to 20 files at the same time.
Windows 98 / ME
 | Download capacity: 64 (= 512 / 8)
 | Upload capacity: 60 (= 128 / 8)
 | Download limit: none (remove the check)
 | Upload limit: 12
 | Hard Limit: 300
 | Max connections: 200
 | Max new connections / 5 sec: 20
 | Do not download more the 12 files at the same time

If you use USS in Preferences -> Extended Preferences then the best is to remove all check marks on the limits and let eMule manage the bandwidth. It will make sure that you have a maximum upload for maximum credit collecting and that other internet applications like online games or surfing run smoothly.
Top
How can I increase my download speed?
Apart from the correct settings only the files you want to download decide the speed. To get a good average performance mind the following:
• eMule should run very long. The longer the better - prefer always
• Do not download only one file
• Get files with 150 or more sources
• Do not try to get the latest releases, at least not fast
• Upload as much as possible to gain credits
• Do not watch eMule. It doesn't like it.
Top
Which download rates may I expect?
If you feed a well configured eMule with some good files you usually get between 20 kB/s – 30 kB/s after some startup time. There will be times where it is much slower but there are also times you may reach 2 to 3 times this value.
Top

How large should the queue be?
A long queue increases the effectiveness of the Credit system. Very high QR values do not mean that you will never download from these sources as there are many modifiers which cut down the waiting time.

Top

Update on: 2004-02-27 by Monk

03.04.2004 11:44


310

 Credits
> Where can I see my credit score?
> I lost /deleted my clients.met file. Are my credits gone?
> Are credits secure?
> How to lose the credits anyway.
What are this credits and why should I collect them?
Credits reward users who upload. The transferred amount of data determines the amount of credits. Credits are not global, i.e. the can only be used on the client who grants the credits.
Credits are a major modifier when calculating the progress in another client's queue. The more credits you have the faster you will advance.
Top
Where can I see my credit score?
To prevent manipulating the score, the credits are not stored locally on your hard disk but on the other client's hard disk. It is not possible to count own credits
Top
I lost /deleted my clients.met file. Are my credits gone?
Losing this file doesn't mean that your credits are gone but all credits other people have on your client. eMule creates a backup of the clients.met file (clients.met.BAK) so you can restore the file by renaming the backup to clients.met.
Top
Are credits secure?
eMule uses a key handshake method to make sure the credits belong to this special client. Credits stored for a user are only granted if this authentication has been successful.
Top
How to lose the credits anyway.
As described above the credits are coupled with the secure user authentication. The secret key for this authentication is calculated from information which is stored in preferences.dat and cryptkey.dat. Should one of this files be lost you will no longer be able to prove that you are the rightful owner of the credits.
If you lose only cryptkey.dat, it is mandatory to delete the preferences.dat file, too.
Top

Updated on: 2003-09-03 by Monk

03.04.2004 11:46


311

 Downloads & Shared Files
> What does this colored bar in Transfer mean?
> What are the xx / yy (zz) values in the Sources column?
> What does QR mean?
> Why do my Sources show Asked for another file?
> How to download in alphabetical order
> What does Too many connections mean?
> Can I change a download's name?
> What do the red and green exclamation marks mean?
> How can I add a comment / rating to a file?
> How do I know that a file is a fake?
> My downloads will not complete.
> My downloads are finished but show Errorious
> My downloads are finished but don't appear in incoming files
> The folder for temporary files is too big. May I delete it?
> How can I delete / unshare files

My downloads have vanished from the list
This may happen after a bad crash or updating to a new version.

• | A downloads.txt file is created in the eMule directory. It contains each file in the dowloads list as eD2k with its associated .part file. You can either redownload the file by using the link or try to reestablish the broken link between .part and .part.met with tools like MetMedic or DonkeyDoctor.
• | Check if the correct path to the temporary folder is entered in Preferences -> Directories
• | Replace the .part.met files in the temporary folder with their .part.met.BAK backups.
• | Check out the chapter Troubleshooting in the Help.
Top
What does this colored bar in Transfer mean?
The colors show the availability of file parts. Red means that no source for this part is currently available. See this topic for more details.
Top
What are the xx / yy +aa (zz) values in the Sources column?
The values denote the numbers of sources found for a download.
• xx - Number of useful sources
• yy - Total number of sources
• + aa - Number of Asked for another file sources (only shown when Advanced Controls enabled)
• zz - Currently transferring sources
Top
What does QR mean?
QR is short for queue rank and is your position in the other client's queue. Sources with a QR below 20 can be expected to start transferring soon. Credits help to advance in this queue more quickly.
The queue rank is not lost should your IP change or eMule is closed for a short time.
Top
Why do my Sources show Asked for another file?
eMule occupies only one slot in another client's queue. If another user has more than one file you want to download eMule will only queue for one file and when this is finished it switches to the other one. The same source will have the Asked for another file note in the file which cannot be queued. See Source Management for more details.
Top
How to download in alphabetical order
It makes sense to download files belonging together in alphabetical order to use the found sources as efficient as possible. Check that the files are named alphabetical in the way you want them to download (sort after Filename, hit F2 to rename), create a category for them and move the files to this category. In the context menu of the category tick Download in alphabetical order. Advanced Controls have to be turned on for this to work. See Source Management for more details.
Top
What does Too many connections mean?
This source status means that more sources are to be processed than connections can be opened. It usually appears when too many files are added to the transfer list or the Hard Limit is set too high.
Top
Can I change a download's name?
You may change the filename of a download to anything desired as a download is not recognized by its name but by an unique hash value. Point to a download an chose -> Show File Details from the right click menu or press the middle mouse button. Mind the files extension when changing the name in the File Name tab.
Top
What do the red and green exclamation marks mean?
The exclamation marks are an indicator for a comment or rating for this download.
• Green = positive rating
• Red = negative rating
Top
How can I add a comment / rating to a file?
You can add comments and ratings in the Shared Files main tab. Just click the middle mouse button or right click -> Edit File Comments on any shared file.
Please use helpful comments!
Top
How do I know that a file is a fake?
You can easily recognize fakes by looking at the found filenames. Right click on any download -> Show File Details -> File Name or middle mouse button opens a list of all found file names for a download. If the file names differ a lot or are contradicting it is probably a fake. Search results showing an explorer style + also have different file names found.
Top
My downloads will not complete.
Does a download not complete for a very long time, two things may be responsible:
No complete sources:
If the progress bar shows red parts that never turn blue and all found sources have the same part missing then the file is probably dead and will never finish. The Last seen complete column in the Transfer List shows the date all parts of the file were available.
Corrupted download:
The Log window in the Server main tab displays an entry if a corrupted part has been received. If you always get a corruption for a specific file part all the time it is possible that this download is totally corrupted (rare occurrence).
Top
My downloads are finished but show Errorious
This error usually appears when the folders for temporary files and incoming files are on different hard disks or partitions. eMule cannot finish the download because there is not enough space free on the incoming disk.
Top
My downloads are finished but don't appear in incoming files
When eMule displays a download as finished but the file does not get moved to the incoming directory you can do this manually. First look at the -> File Details and make sure that the file is really finished by comparing sizes. Also note down the .part file's number and copy the filename to the clipboard. In the Window's Explorer navigate to you temporary folder and move the appropriate file to your incoming folder and rename it to its final filename using the name you copied to the clipboard. Mind the file's extensions. Most of time such files do no longer have a .part.met file associated.
Top

The folder for temporary files is too big. May I delete it?
This folder stores all your not completed downloads. Deleting it means deleting all current downloads! Because of the transfer system used in eMule it may happen that the entire space for the finished download is occupied although only a few kilobytes have been downloaded.
Top

How can I delete / unshare files
eMule shares files as soon as:

• | a download's part (chunk) has been completed and checked for errors
• | they are in the folder for Incoming Files or are marked as shared in Preferences -> Directories -> Shared Directories

To remove a share you must move the files out of your incoming or folders marked as shared. In the main windows Shared files you can also delete files by using right mouse button -> Delete.
Sharing current downloads cannot be disabled.
Top

Update on: 2004-08-18 by Monk

18.07.2004 14:27


312

 Using eMule
> How can I add a friend?
> How to allocate a friend's upload slot
> How can I clear the search auto-completion history?
> What is the meaning of the icons in front of sources etc?
> May I kick or ban other users?
> Why do I get only 201 results in a search?
> Should I set all my files to high priority or release?
General Tips
Many functions in eMule are accessible by the context menu. This is a menu that opens on a right mouse button click on many different objects. Also many areas and objects react on double clicks or even middle mouse button clicks. A quick menu opens by pressing ALT + x. Just try out the different combinations. It is useful.
Top
How can I add a friend?
Friends are managed in the Messages main window. To add a friend, right click in the Friends list and choose -> Add Friend. You need to have following information:
• IP Address – mandatory. You got to have it. Just ask your future friend.
• Port – mostly 4662; also mandatory
• Name – Choose any name. Not needed.
Another way to add friends is by directly right-clicking on any source in the Transfer main window and choosing -> Add to Friends. eMule will then fill in all required information.
Top
How to allocate a friend's upload slot
A right click on any friend lets you give him a friend upload slot. This upload slot will get active as soon as the next one is free allowing your friend to download. Friend-slots do not increase the upload to them it just grants a normal upload slot.
Top
How can I clear the search auto-completion history?
Click into the search field then press CTRL or ALT then DEL.
Top
What is the meaning of the icons in front of sources etc?
Find a detailed description in the Icons chapter.
Top
May I kick or ban other users?
No. This function will never be implemented in eMule as it contradicts its philosophy.
Top
Why do I get only 201 results in a search
Searching causes a heavy load on the servers. To limit the impact of many searching clients eMule returns a maximum of 201 results on a search. If you want more, use the web based search Filedonkey
Top
Should I set all my files to high priority or release?
No. Priorities are used to favour certain files over the other. The priorities are relative to each other, i.e. all files to low priority is the same as all files to high or all files to normal.
Priority for downloads influences how eMule treats the file when searching for sources or when processing connections. Upload priority determins which files eMule favours when someone requests this file. Other clients who request high priority uploads will advance faster in your queue.
Top

Updated on: 2003-09-03 by Monk

03.04.2004 13:14


313

 Misc
> What is a Mod?
> Are Mods better or faster?
> I get messages that eMule is banned
> Where can I get further help?
> Is eMule anonymous?
> My Firewall reports attacks or why does eMule send mails?
> My firewall still reports connections after I closed down eMule
> What is the IP Filter?
> May I copy the Help / FAQ for my own site?
Why is surfing slow when eMule runs?
Depending on the settings eMule may open quite many connections and also uses much bandwidth. This can slow down other internet applications, i.e. surfing the WWW. Especially wrong / too high connections settings cause serious performance drops while surfing.
Top
What is a Mod?
As anyone can use eMule's source code other people have developed modified versions of the original one. These versions are not supported by the official eMule team.
Top
Are Mods better or faster?
Mostly no. The official eMule versions profit from mod development but the modders cannot change the eMule's inner working much without rendering it incompatible to the rest of the network. This fact makes any speed improvements very unlikely.
The mods offer new feature and new bugs which you may like or not, yet some of them have unfeatures which are extremely harmful for the whole network. These leecher versions must not be used and the official eMule tries to cut them down by security features and by banning them.
Mod versions offered on our forums play fair and stick to the network's rules.
Top
I get messages that eMule is banned
The official eMule versions do not create these messages, they are from mods. If you are using the official version you can safely ignore or filter them.
Top

Where can I get further help?
If there are still open issues after reading the FAQ and help you may want to ask in:

• | the Forum (please use the search function before starting new threads)
• | IRC - just go to the IRC main window in eMule and press connect. To enter the english eMule help channel type /join #emule. There are also other language chat rooms like #emule-french, #emule-spanish or #emule-dutch.
Top
Is eMule anonymous?
P2P networks all rely on a direct connection of two users to transfer data. To accomplish this the IP of the target client has to be known. This IP makes the user identify and trackable. There are only two ways of guaranteeing anonymity: routing the traffic over anonymizing proxy servers or bouncing it across other clients.
Proxy servers have numerous disadvantages. They can be closed down, the degree of anonymity depends on the trustworthiness of the admin and the traffic they consume costs a lot of money. Let's assume an average 100.000 client eMule server. Each of the connected client causes 10kB/s traffic in each direction. The server would have to cope with a transfer volume of 2.000MB (1,9GB) per second. No one can afford such servers.
Routing all traffic over third clients causes a similar problem as half of the traffic would be used for anonymizing. This means that each user would have to upload twice as much as now to keep the network's performance on the current level.
At the moment a secure and sensible way of anonymity in a P2P network is not feasible!
Top
My Firewall reports attacks or why does eMule send mails?
Software firewalls analyse traffic by looking over which ports the traffic is send. Many ports are commonly used only by certain applications. Emails for example usually uses port 110 to receive mails and port 25 to send mails. Also trojans and other pest software uses specific ports.
Now all ports are freely configurable in eMule and some users are setting them to ports which are normally used by other applications. This can mean that firewalls report attacks or think that eMule sends mails only because eMule has a connection on a certain port.
If you use the official eMule version you can rest assured that it will not send any unwanted information. Also for the current version .30b no exploits are known.
Top
My firewall still reports connections after I closed down eMule
Your eMule gets known in the network as it is a source for other clients. Also the server propagate your client as source for the files you share. When you shut down eMule you will still receive traffic from other clients asking if a connection is still possible. This effect will subside after a while.
Top

What is the IP Filter?
The IP filter is used to block traffic of certain network addresses which may be harmful for the network. The most popular page for filter files is Methlabs, Bluetack or Lussnig's IP Filter. Add the link to the filter file, e.g. http://bluetack.co.uk/config/antip2p.txt to the Preferences -> Security -> Update from URL field and press Load. Block lists can also be added directly if they point to a *.zip file.
Top
May I copy the Help / FAQ for my own site?
You may copy any parts of the Help and FAQ as long as you keep the author and place a link to http://emule-project.net. It is nice and shows respect to drop me a note when doing so.
Top

Updated on: 2004-08-18 by Monk

18.07.2004 13:58


100

 Icons

Transferring or receiving hash set from this client

On Queue or asking this client

Connecting to this client

No needed parts, asked for another file or unable to connect because of a low ID

Status unknown

New Message

Normal eDonkey or early eMule client

Client which is able to understand the extended eMule protocol

Normal client with a high credit value (which means he has a higher priority)

Client which is able to understand the extended eMule protocol and has a high credit value

mlDonkey client

mlDonkey client with a high credit value

eDonkey2000-Overnet-Hybrid client

eDonkey2000-Overnet-Hybrid client with high credit value

Shareaza Client

Shareaza Client with credit points

Clients authenticated by secure user identification

high ID in eD2k (server) network and Kademlia

connected, high ID in eD2k, low ID (firewalled) in Kademlia

low ID in eD2k, high ID in Kademlia

both networks low ID

Kademlia not connected, high ID in eD2k

eD2k not connected, high ID in Kademlia

Kademlia not connected, low ID in eD2k

eD2k not connected, low ID in Kademlia

not connected

Kademlia contact - good

Kademlia contact - failed to answer once

Kademlia contact - probably dead, will be removed

eMule's tray icon when connected to a server with a high ID

eMule's tray icon when connected to a server with a low ID

eMule's tray icon when not connected to a server

A file comment or positive rating has been entered for this download

File rating Fake, Corrupt or Invalid

Applies to version: .42a +
Last update on: 2004-02-27 by Monk

03.04.2004 8:03


101

 Colors of the Progress Bar

Each download in the Transfer tab has a coloured bar to show current file availability and progress.

(flat style) [image] (shaded sytle)

Black shows the parts of the file you already have
Red indicates a part missing in all known sources
Different shades of blue represent the availability of this part in the sources. The darker the blue, the higher the availability
Yellow denotes a part being downloaded
The green bar on top shows the total download progress of this file

(flat style) [image] (shaded sytle)
A green bar stands for a completed download.

(flat style) [image] (shaded sytle)
A dark red or blue progress bar denotes a stopped or paused download.

If you expand the download you see its sources with the corresponding bar. To see the sources just double-click a download (or single click, depends on the settings in Preferences -> General). Here the colours have a slightly different meaning:

(flat style) [image] (shaded syle)

Black indicates parts you already have
Blue are parts you still need for this download
Silver stands for parts this source is also missing
Green parts are currently downloading
Yellow denotes a pending (already requested) part

Source Count
The four values xx / yy +aa (zz) displayed after the progress bar is the source count for this file and shows following information.

• xx - Number of useful sources
• yy - Total number of sources
• + aa - Number of Asked for another file sources (only shown when Advanced Controls enabled)
• zz - Currently transferring sources

Obtained Parts
This bar appears in the upload queue if supported by the other client. It shows the progress of the file this user is downloading.

Black are parts this user has already completed
Silver ones are parts still missing
Green parts are currently uploading
Yellow denotes a pending (already requested) part

Availablity of shared files
Each shared file show its availabilty in the form of a bar. The color coding is similiar to the one used with the progress bar

Red indicates a part missing in all known sources
Different shades of blue give an idea how well spread different parts are

Last update on: 2003-09-27 by Monk

29.02.2004 15:30


102

 QR - Queue Ranking

eMule clients show a QR:[x] in the source view.
QR stands for queue ranking and it is your current position in this source's queue.

Obviously, a lower value is better.

22.07.2003 10:20


103

 ID Explained

ID is a value calculated from the client's IP address. It is assigned by the server, when eMule successfully connects. The purpose of the ID is to give an indication if proper communication is possible between two clients.

After connection the ID is displayed in the Server's Log window.

eMule does not display the ID any further but shows the ID status by the globe in the lower right corner next to the connected server.

indicates a high ID in all netwerks
indicates a low ID in all networks

A high ID means the port chosen in Preferences -> Connections (default 4662) is open and freely accessible.

Whereas a low ID means this port is blocked or cannot be reached. This can be caused by firewalls, routers or proxy servers.
Having a low ID does not mean that no up- or download is possible but has several disadvantages:

- No IP is known of the machine eMule is running on therefore all requests like queue or connection requests to this client have to be routed over the server, the low ID client is connected to. This routing causes considerable amount of CPU load on the server thus reducing the maximum number of users the server can cope with. Lugdunum's servers limit the number low ID users or even ban them at all.

- Two clients on low ID cannot connect to each other, as it is not possible to route messages over two different servers. This will lead to less sources for the downloads

- On busy servers it may well happen that the messages gets lost and eMule misses important information about queue progression or download requests. This may lead to fewer credits and worse downloads.

Notes:
- The ID issue only affects message exchange between clients. Actual data transfer is still handled client to client.

- If it is not possible to get a high ID, it is better to connect to low user servers as they have more resources left to deal with it than the big congested ones.

- You can also get a low ID when the server you connected to, is too busy to answer properly, or simply badly configured. When you are sure your settings are ok and you should have a high ID, connect to another server. Run eMule and use this test script (thanks to TheDonkeyNetwork) to verify your configuration.

- If the ID is high, it does not matter how high it is. An "even higher" ID is not better or offers any advantages.

- If an ID is low, it does not matter how low it is. A low ID is a value less than 16777216.

- To compare your IP and a High ID the conversion is as follows: for IP = A.B.C.D the High ID = A + 256*B + 256*256*C + 256*256*256*D.

Important:
Since .23a low ID sources are dropped by eMule to keep load on servers to a minimum. Only low ID sources connected to the same server your client is connected to and low ID sources who want to download a file from you are accepted. Also low ID sources are not traded via Client to Client Source Exchange.

Last update on: 10/12/02

29.02.2004 15:32


104

 Rating and Score

The Queue list shows the clients currently waiting for an upload slot. This list is shown by pressing On Queue in the Transfers tab.
Most of the values shown are pretty self explaining except Rating and Score.

Rating
Initially each client on queue has a rating of 100. This start value is modified according to the shared file the users requests and some other factor:

> | Banned Modifier:: x0 Banned users get no Rating and thus no upload slot.
> | Low ID Modifier: none [x0.8] Versions prior v.27a assigned a modifier of 0.8 to low ID users. This has been dropped
> | Connected Modifier: none [x1.5] The bonus of x1.5 for being already connected has been dropped with v.27a+.
> | Credits Modifier: x1 - x10 The credit system calculates this major modifier according to the upload / download ratio.
> | File priority for shared files. Modifier: x1.8 - x0.2 Users requesting a file for download will receive a modifier according to the chosen share priority of the file. Versions prior v.27a use the values in [ ].
 | Release: | x1.8 [x5]
 | High: | x0.9 [x2]
 | Normal: | x0.7 [x1]
 | Low: | x0.6 [x0.5]
 | Very Low: | x0.2 [x0.2]
> | eMule version older v.20a Modifier: x0.5 Versions prior v.20a cause high network load and get a penalty modifier of x0.5.

Example:
A client has earned a credit modifier of x8 by uploading much. He is requesting a file with a high priority. His total Rating will be: 100 x 8 x 0.9 = 720

Score
The score is calculated with the same modifiers as described in Rating but also takes the waiting time of the client into consideration. The score determines the allocation of free upload slots. Clients with high scores and *** after the value are next to receive an upload slot.
The formula to calculate the score is:

Score = Rating x [Waiting time in the queue [s]] / 100

Clients with a total modifier > 1 will have a yellow client icon.

Last update on: 2003-04-13 by Monk

29.02.2004 15:33


105

 Lists
The Transfer tab provides various information about your current down- and uploads. The upper part of this tab displays the downloads, the value in parenthesis ( ) is the number of current downloads.
The lower part usually displays current uploads. This display can be toggled to show other information as well.

To switch from list to list click on the current list's name. The information in the lists are pretty self explaining.

Applies to version: .27a +
Last update on: 2003-03-13 , Monk
29.02.2004 15:34


106

 Files Used

During eMule's runtime quite some files are used or created on first start. Most of them are created in eMule's config folder, others reside in the temporary directory as specified in the Preferences or directly in eMule's installation directory.

o | Known.met The Known.met saves all files eMule knows of whether they are shared files or files currently in the download list. For every file information like file size, path to the file, hash sets, hash values and some statistics are saved.
o | Clients.met This file stores all users who have credits with your eMule
o | Server.met Contains all known servers.
o | Emfriends.met If users are add to the friends list they are stored in this file.
o | Preferences.ini Saves all options set in the preferences dialog and information about visual details like column size etc.
o | Fileinfo.ini Comments or Ratings for your own shared files.
o | Category.ini Stores the settings of your categories like name, comment and colour coding.
o | Ipfilter.dat This file contains the IP ranges and access levels to be filtered by the IP Filter. Also see Preferences -> Security
o | Onlinesig.dat The Online Signature is a small file which contains the server eMule is connected to and up- and download statistics. Maybe used for IRC scripts or signature images.
o | Preferences.dat Saves the user hash. This is a value calculated at eMule's first start and is used to identify this client in the network. Used for credit system and friends.
o | Sharedir.dat Holds all paths to shared directories.
o | Staticservers.dat Static servers never change their IP and are theoretically always online in the network. These servers can be added to staticservers.dat by the context menu (right mouse button) of the server list. See also Preferences -> Server
o | Adresses.dat eMule updates its server list at startup if valid addresses to server.mets are provided in this file. Preferences -> Server offers a button to edit this list and the option for updating at start up. The file may contain multiply entries (one each line) but only the first address to deliver a valid server.met is used.
o | AC_SearchStrings.dat Each search string that has been used is recorded and an auto completing is offered if a new search matches previous ones.
o | AC_ServerMetURLs.dat Same file as the the one above. The only difference is that this one is used to store entered URL to server.met files. Mind that many sites regularly change their addresses to the server.mets.
o | Cryptkey.dat It contains the unique 384 bit private RSA key of your client
o | eMule.tmpl The *.tmpl files are required for the Webinterface. They define layout and options of the displayed pages.
o | xx.part Part files are unfinished downloads. eMule is able to download from more than one user at the same time, so the *.part files always have the size of finished download. Missing parts are simply filled with zero.
o | xx.part.met Every *.part file has a corresponding *.part.met file. To identify a download in the network and to check for errors each download is divided in about 9 MB parts. For each part a so called hash value is calculated. Then a new hash value is created of the complete set of these part hashes. This information together with the file name and the status of the hashes are stored in the *.part.met files.
o | xx.part.met.BAK A backup of the *.part.met files is created as it is very bad if such a file gets corrupted by a crash. See Troubleshooting for help, if your downloads vanish due to corrupted *.part.met files.
o | eMule.log Saves the output of the Log window in the Server pane if the appropriate option in Preferences -> Extended is turned on
o | eMule_Debug.log Saves the output of the Debug window in the Server pane if the appropriate option in Preferences -> Extended is turned on

Applies to version: .29b +
Last update on: 2003-06-20 by Monk

02.05.2004 16:10


516

 Controlling eMule

eMule can be fully controlled by using the keyboard and keyboard shortcuts. It follows closely the approach which is used in a Microsoft Windows environment:

• | Functions, that have a letter in their name underlined with a _ can be directly called by pressing Alt + underlined letter.
• | On a standard Windows keyboard the contextmenu key besides the left Ctrl key opens the context menu on selected items.
• | Single items in a list view like server list or download list can be selected by holding down the Ctrl key and clicking on the single items with the left mouse button. Holding down the Shift key will mark all items between two clicks.
• | Jumping to items in a list view can be easily done by pressing the first letter of the item's name.

Alt + X | eMule's Hot menu
Alt + C | Connects / Disconnects / Cancels connecting to server or Kad
Alt + K | Kademlia main window
Alt + V | Server main window
Alt + T | Transfer main window
Alt + S | Search main window
Alt + F | Shared files main window
Alt + M | Messages main window
Alt + I | IRC main window
Alt + A | Statistic main window
Alt + P | Preferences dialog
Alt + O | Tools menu
Alt + H | Opens eMule's help file
Alt + F4 | Quits eMule
Ctrl + C | Copies the selected server(s) or download(s) to the clipboard. Entries in logs, messages or IRC chats may be copied as well.
Ctrl + V | Pastes server(s) or download(s) from the clipboard to the appropriate window in eMule. Also pastes text in messages or IRC.
Ctrl + A | Selects all items in a list view.
Ctrl + F | Opens the search dialog, which can be used in the server list or in the results of a network search.
F1 | Opens eMule's help file
F2 | Renames the selected download
(Shift + ) F3 | After a search with Ctrl + F, F3 jumps to the next hit matching the search criteria and Shift + F3 jumps to the previous hit.
Esc | Minimizes eMule
Alt + Return (Enter) | Shows the file details of a selected download
Ctrl + Del or AltGr + Del | Clears the entries in the auto completing of server.met download, search or Bootstrap IP
Tab | Completes nicknames in an IRC chat after the first few letter have been typed
Double click download | Expands the download to show its sources
Double click server | Connect to the selected server
Double click status bar (first field) | Shows last log entry
Double click status bar (third field) | Opens Statistic main window
Double click status bar (fourth field) | Show connection details dialog
Double click status bar (filth field) | Opens the Messages main window
Double click shared file | Opens the file with standard application if download is already complete
Alt + double click download | Show all sources which have needed parts of the download
Ctrl + double click download | Shows all sources with a QR > 0
Shift + double click download | Shows all currently active (uploading) sources
Middle mouse button download | Opens the file details dialog of the selected download
Middle mouse button shared file | Opens the Comment and Rating dialog of a shared file
Right mouse button | Opens the context menu with additional options and functions in many places of eMule.

01.08.2004 12:51


107

 General

Nick
Enter your nick name as it will appear to other users.

Language
Choose your favourite language from the drop down list.

Misc Otions

o Beep on errors
If an error or file corruption is encountered the PC speaker will beep

o Bring to front on link click
As eMule uses the eD2k network downloads and servers can be added via special web links.
Set eMule’s behaviour on web link click. Choose either a flashing eMule task or the eMule window poping to top.

o Enable Online-Signature
A small file named onlinesig.dat will be written in eMule directory. This file has the following format:

[Online status]|[Connected Server]|[IP:port]
[Current Download]|[Current Upload]|[Users on queue]

This information can be send to web space via Dra.:.god's Online Signature tool or be processed in any way.
In the future further functions may be added.

o Prompt on exit
A message box will appear on closing eMule asking for confirmation.

Startup

o Check for new Version
If this option is checked eMule will look for a newer version on each start up. The slider sets the update interval for the version check.
If a newer version is found you can download it on www.emule-project.net. To upgrade eMule simply install / extract the new version in the same folder your current eMule is in. All settings and downloads will be automatically used by the new version.

o Show Splash screen
Shows a nice splash on start up of eMule if checked

o Start minimized
This will start eMule as a tray icon

Edit Webservices
The internet offers some web based services like search engines for the network. These web services can be used directly from within eMule. To configure them the file webservices.dat in eMule's install folder has to be edited. The button Edit Webservices gives quick access to this file.

Example for a WebServices.Dat:
#########################################
# Webservices Configuration File
# input one service per line
#
# Format: Name,URL
#
# Placeholders:
# #filename -> name of the file
# #hashid -> hashid of the file
# #filesize -> size of the file
#
# Example:
# Fake Check,http://www.some-well-known-search-engine-for-downloads.com/search?p=ed2k:#filesize:#hashid
# eMule Homepage,http://www.emule-project.net
# eMule FAQ,http://www.emule-project.net/faq/
#
# Comment lines begin with # or /

eMule Homepage,http://www.emule-project.net
eMule FAQ,http://www.emule-project.net/faq/

This example will add eMule Homepage and eMule FAQ to the web services. These services can be access via the context menu of the Downloads list.

Ed2k Button
If this button is pressed eMule is associated with the eDonkey2000 web link format for downloads and servers.

Note:
Some other p2p applications may change the link settings. Correct settings can be verified in the registry using regedit (Start -> Run -> regedit):

HKEY_CLASSES_ROOT\ed2k\shell\open\command
Name: (Standard)
Type: REG_SZ
Data: "Path to emule.exe(with quotes!)" %1

and

HKEY_LOCAL_MACHINE\SOFTWARE\Classes\ed2k\shell\open\command
same as above

If you have problems with eMule's link association delete all entries after HKEY_CLASSES_ROOT\ed2k\... and HKEY_LOCAL_MACHINE\SOFTWARE\Classes\ed2k\... then press the eD2k Link button in eMule again.
Backup registry before and reboot after any changes to registry!

Applies to version: .27a +
Last update on: 2003-03-12 by Monk
29.02.2004 7:24


108

 Display

o Progressbar Style
The slider affects the amount of 3D shading of the Progress Bars.

o Tool tip delay time (seconds)
If the mouse hovers on a download a little note will appear with information on this download. Specifies the delay until this tip pops up.

o Downloadlist Doubleclick to expand
This option toggles, whether a double or single click in the download list is needed to expand and show the sources or a single click.

o Indicate downloads with comments/rating by icon
Shows the [image] -icon (comment, positive rating) the [image] -icon (negative rating) for downloads in the Transfers list.

o Show percentage of download completion in progress bar
A %-completed value will be added for each download in its progress bar.

o Show transfer rates on title
Displays current Down- and Upload speed in eMule's window title.

o Show download info on category tabs
Will display two values (x/y) right after a categorie's name. The first value (x) is the number of currently active (downloading) files and the second one (y) the total number of files for this category.

o Minimize to tray icon
eMule will not minimize to task bar but to the tray if this option is checked.

o Auto clear completed downloads
eMule shows finished downloads with a green progress bar. This option will remove them automatically from the downloads list.

Save CPU and Memory Usage

o Disable Known Clients List
eMule keeps track of all clients it connected to. To save memory this list can be disabled with this option. Turn it off for low memory systems.

o Disable Queue List
Similar to the Known Clients List the Queue List will also consume system resources. Disable to save them.

o Do not update queue list in real time
The information displayed in the queue list will be updated not as often which will save some CPU time.

o Do not recreate statistics graphs on resize
eMule may shortly freeze when the window is resized. This is caused by redrawing the graphs with saved data. If this option is checked, the graphs will not be recreated and start new.

Select Font
This button opens a dialog to choose the font, style and color of the text displayed in the server, messages and IRC windows.

Auto completion (History function)
The history saves all user entries from the search, Kademlia bootstrap IP, server update URL and IP filter update URL fields and offers to complete the entry if it finds something suitable in the saved entries.
The Enabled checkmark allows to turn off this option and the Reset button will clear all entries.

Applies to Version: .42f +
Last Update: 2004-02-27 by Monk
01.05.2004 18:40


109

 Connection

First find your ISP’s speed in your contract or on the ISP’s webpage.

The values for speed are usually given in kilo Bits per second [kb/s] but the values to be entered in eMule are in kilo Bytes per second [kB/s]
To convert to kilo Bytes simply divide the kilo Bits value by 8

Example:
Maximum Downstream: 768kb/s ÷ 8 = 96 kB/s
Maximum Upstream: 128kb/s ÷ 8 = 16 kB/s

The Wizards has most of the common connection types preconfigured. Use it to find the correct settings for your line.

Capacities
o Download
This value equals the maximum downstream bandwidth. In the example above it would be 96.

o Upload
The maximum upstream. In the example it would be 16.

Note:
The Capacities are important for the connection management in eMule. Check for correct values.

Limits
o Download
This is the maximum download speed in kB/s eMule is allowed. It is recommended to set it to unlimited by removing the check mark.

o Upload
This is a very important setting. It denotes the maximum upload you give to the network. The recommended setting is not set it higher than ~75% of your Upload Capacity. Or try Upload Speed Sense - see below.

Aspects to consider:
Setting the Limits to unlimited using Upload Speed Sense
When activating Upload Speed Sense in Preferences -> Extended Settings and removing the check on Upload Limit eMule will use all available upload for best performance. Automatic monitoring of the ping times and upload adjustment will ensure smooth surfing or online gaming while maximizing download by credit collecting.

Setting Upload limit too high
Every download needs some spare upload bandwidth to make requests, acknowledge packages etc. So if you set this limit to high the upload will slow your download as no upload bandwidth is available to make these requests.

Setting Upload limit too low
eMule features a credit system based on how much you give to the network. A lower upload means fewer credits and a longer wait time in queues.

Client port
o TCP
eMule uses 4662 as default port for downloading data from another client. It is important that this port may be contacted from outside, this means it must not be blocked by a firewall or dropped in a router because of a missing forwarding rule. In this case you would have a low ID. Changing this port may be necessary as some ISP seems to throttle the speed on the default eMule ports. If the port is changed this has to be adopted in any router/firewall rules also.

o UDP
The UDP port is the connection port for the Kademlia network and also handles many features like eMule's extended protocol. Using inter client UDP reduces the connection overhead and also lessens load on the servers.
It is necessary that this ports is open and forwarded just like the TCP port or Kademlia will receive the status firewalled, which is the same as low ID on a server. If it is not possible to open this port, it should be deactivated.

o Open these ports on the internal WinXP firewall
If the internal Windows XP firewall is activated this button will automatically open the entered ports to allow unblocked communication in eMule. Only the UDP and TCP port are opened and it is recommended to use this function together with the Preferences -> Extended Settings -> Open/close ports on Win XP firewall when starting/exiting eMule. This offers best protection. This feature only works for Windows XP (w/o SP) and XP SP1.

o Test Ports
This button will open a web page in the browser which runs a script to verify that the entered ports are opened and will give a high ID. If the page displays an error, the settings for router and/or firewall have to be corrected.

Connection Limit
o Max Connections
This is the maximum allowed number of TCP/IP and UDP connections.
Connections are only opened if there is data transfer in progress, for search and queue requests or Client to Client Source Exchange.
Altering this value is normally not necessary, except on Windows 98/ME, then don't set this value any higher than 100.

Note:
(Too many connections) in an expanded download means, that the limit of new connections has already been reached. These sources are "on queue" and will be processed as soon as new connections are opened.

Max Sources Per File
o Hard Limit
Hard Limit is the maximum number of sources allowed for a file. If this limit is reached eMule stops accepting sources for this file.

Network
eMule features two different networks. One is a server based network following the traditional eD2k system The other one works independent of servers and uses a concept known as Kademlia. See the Network Guide in this help for a more detailed description.
The checkboxes allow to choose to which network(s) eMule connects when the Connect button is pressed.

Autoconnect on startup
This will tell eMule to establish a server and/or Kademlia connection right after start up.

Reconnect On Loss
If the network connection is lost, eMule will automatically try to establish a new one. Recommended is checked.

Show Overhead Bandwidth
This option will display the up- and download overhead in the eMule status bar. They are the values in parenthesis ( ) next to the current up- and download speed. This overhead calculated from the amount of data needed to manage source asking, to open connections and to control any other form of communication between clients. This bandwidth is lost for up- and downloading.

Important:
If the sum of your current upload and overhead is near your upload limit, eMule opens too many connections or has to manage too many sources. In this case you have to lower your Max Connections and/or your Max Sources per File or you'll suffer from bad down- and uploads.

Note:
The number of clients in your queue do not cause any additional traffic and have no effect on overhead.

Applies to version: .44a+
Last Update: 2004-09-11, Monk
12.09.2004 7:31


110

 Proxy

A proxy server is a dedicated machine that relays the traffic of a connecting user to its target address and vice versa. Proxy servers are usually used for 4 different purposes:

> | Firewall Proxy servers can be configured to allow only certain ports, protocols and addresses.
> | Router Often used to provide simultaneous access to the internet for many computers in a LAN.
> | Content cache Content caching proxies have huge databases of regularly accessed internet content and services. This may speed up access to these contents.
> | Anonymizing Some, even free proxies, do not forward any user specific information, like IP or referrer etc, to the target address. The only computer the destination of the connections sees is the proxy server. The freely available anonymous proxies in the internet are not well suited for eMule. Most of them are slow, unstable and will probably deny eMule any connection. Using such a proxy leads to a serious performance drop. Locally running proxies do not offer any anonymizing.

If eMule is used on a computer which is shielded by a proxy the correct settings for the proxy server have to be entered. Providing wrong settings here will result in no connection.

Important:
Only enter a proxy if you are sure you have one and you are able to provide the correct information. Proxies are only seldom used on home PCs and offer no advantage for users outside a LAN. Hardware routers or modems are no proxies!

General

o Enable
Enables the proxy support.

o Proxy Type
There are different types of proxy server. For eMule to connect through a proxy, its type must be provided.

> | SOCKS v4 / v4a SOCKS proxies offer an application independent protocol for connecting two hosts without direct IP reachability. v4 and v4a servers are only capable of relaying the TCP protocol. When this type is used the disable checkbox in Preferences -> Connection -> UDP Port has to be ticked.
> | SOCKS v5 The same limitations as for SOCKS v4 / v4a applies.
> | HTTP 1.1 Uses the Hypertext Transfer Protocol v1.1 for the connection. Similar to SOCKS v4 this type does not support the UDP protocol, so the same procedure as above applies. HTTP Proxies usually cannot open listening ports. No high ID will be possible when using this type.

o Proxy Host
Enter the host address of the proxy server.

o Proxy Port
The port to connect to the proxy server has to be specified. Typically proxies use port 1080.

Authentication
Some proxy servers need a username and password for allowing connection. If so, Authentication has to be enabled and the proper credentials have to be entered.

Automatic Server Connect without Proxy
Checking this option will bypass the Proxy settings when auto-connecting to eMule / eDonkey servers.

Applies to version: .28a +
Last update on: 2003-11-30 , Monk

02.05.2004 15:19


111

 Server

Remove dead Server after [n] retries
When a server does not correctly response to a status query it is counted as a failed attempt. After [n] failed attempts the server is deleted from the list on next query.

Auto-update serverlist at startup
In the directory you unzipped eMule to, you’ll find the file adresses.dat. This file can be edited by pressing the [image] -button. Enter a vild URL to a server.met and safe the file. If this option is checked eMule will update its server list from the URL provided in the adresses.dat at start up. The file will accept multiple addresses but only the first valid address will be used.

Note:
You can set your default editor in the preferences.ini. Search for TxtEditor= and provide the full path to your new editor.

Update serverlist when connecting to a server
eDonkey servers know of each other to a certain extent. With this options eMule will retrieve the list of known servers from the server it is connected to.

Update serverlist when a client connects
This feature works upon the connection of another eMule client to your client. Both clients will compare their working servers and update their lists accordingly.

Use priority system
In the context menu of the server list, each server can be assigned a priority.

The priority will tell eMule which servers to prefer when connecting.

Use smart low ID check on connect
If you once had a high ID this function assumes that you have configured everything correctly and so disconnects eMule if a server gives a low ID without reason. If you receive 3 low IDs in a row you will get classified as low ID user until you get a high ID again.

Safe connect
eMule asks two servers simultaneously for connection to speed up the process. When Safe connect is on, only one server will be asked to minimize the chance for low ID. Usually not need. Note that eMule still keeps connection to one server only.

Autoconnect to static servers only
In the context menu in the server list allows to add servers to the staticservers.dat in the eMule installation folder. This list will be automatically loaded on eMule start up. Only add servers with static IP or servers that use the DynDNS feature to this list! This option tells eMule to connect only to servers from this list. Having this option checked but not providing valid static servers will result in eMule not connecting!

Set manually added servers to high priority
This option will tell eMule to give each server a high priority that is not added via a server list.

Applies to version: .29b +
Last update on: 2003-07-09 by Monk
29.02.2004 7:39


112

 Directories

Incoming Files
Specifies the directory to which completed downloads are moved. If the default path is changed an existing folder must be entered. eMule will not create this directory.

Temporary Files
Folder or directory where the downloads in progress are stored. Because of the multi threaded download system, eMule creates dummy files (*.part) of the size the finished download will have.
If this folder is changed, the same as for Incoming Files applies and additionally eMule has to be restarted before changes are applied.

Shared directories
These folders will be shared in the network and a list of them may be retrieved by eMule, eDonkey or mldonkey clients if they use their friends feature (depends on setting in Preferences -> Files). If you want to share all subfolders hold down the CTRL key while clicking on the parent folder. This does not work for whole drives/partitions.

o UNC Folders
UNC stands for Uniform Naming Convention. It is common way to access shared resources (folders or entire drives) in a network without having to map this resource. All UNC folders follow this format:

\\server\resource\...

Example:
\\test\DriveD\eMule would point to the folder eMule on the shared disk with the name DriveD of a computer called test

Some notes on sharing files:
Whenever an eMule client connects to a server it transfers a list of the shared files. The server stores this list and makes it available for search or source requests. This file management puts CPU load on the server, the more files, the higher the load and consequently less users the server can cope with.

Please follow these guidelines when sharing in this network:
> | Your Incoming and Temporary directory are always shared so do not add them.
> | The eDonkey network is not well suited for sharing large number of individual or small files, e.g. whole mp3 collections. Zip your files if you are sharing them.
> | Please don't share directories like \Program Files, \Temp, or \Windows nor entire disks

Applies to version: .29b +
Last update on: 2003-06-20 by Monk
29.02.2004 7:40


113

 Files

See my share
The Friend feature allows to view a list of the files you share. With this option the response to a View Shared Files request is set.

Intelligent Corruption Handling (ICH)
Data transfer in the donkey network is organized in chunks. A chunk totals 9MB. Each complete chunk downloaded is checked for corruption; if not corrupted, the chunk is made available for uploading.
Normally, corrupted chunks must be completely redownloaded. ICH tries to reduce the amount of data that needs to be redownloaded and thus saves time if a corruption is detected.

Initializations
o Add files to download in paused mode
When the download list already contains 20 or more items, this option comes in handy, as all new downloads are added with a paused status rather than waiting status. So collecting files is still possible without overloading eMules connections. See Start next paused file when a file completes.

o Add new shared files with auto priority
Completed files or new shared files will be set to auto priority. With auto priority eMule will manage the priority according to the number of requests for a file. Files with only a few requests will get a high priority whereas files with many requests will get a low one. This helps to increase the availability of rare files in the network and is recommended to use.

o Add new Downloads with auto priority
Similar to the option above this one applies to files added to the Transfers list. According to the number of sources found for a download its priority will be adjusted automatically.

Found sources | Priority
0 - 40 | High
41 - 80 | Normal
81+ | Low

o Cleanup Filename
This option automatically cleans up filenames whenever a new download is added to the Downloads list. Special characters like _ , . , [] are removed or replaced by a blank and the first letter of each word is capitalized. Further, special strings which can be defined using the Edit button are also removed from the file name. There are already strings defined which will be used but new ones can be easily added by using | as separator.

Warning:
Images for CD recording software often consists of more than one file, e.g. *.cue/*.bin (CDRWin), *.mds/*.mdf (Alcohol120%), *.ccd/*.../files/help/1033/*.sub (CloneCD), *.bwt/*.bwi/*.bws (BlindWrite). The option should not be used when downloading such files. Changing the filename will result in error messages when trying to burn them as the correct filename is also saved within these files.
If you change the filename anyway, it has to be replaced in the according layout files, too. For *.cue files this can easily be done with Windows notepad but the other formats mostly require some hex editor like UltraEdit or WinHex.

Try to transfer full chunks to all uploads
Turned on, this option tell eMule to upload until a chunk is completed. The advantage of this is that the availability of the files will increase as only full chunks can be shared. When releasing a new file this option is a must, but anyway, using it is recommended.

Try to download first and last chunk first
For the preview function to work the first and last chunk of a file have to be downloaded already. This option will try to get them first. It is not recommended to turn it on, as it will have negative effect on the availability and distribution of the files.

Watch clipboard for eD2k-filelinks
Copying an eD2k Link via CTRL+c from a website or any other source will pop up a message asking if this file should be added to the Transfers list.

Use advanced calculation method for remaining time
This will affect how eMule calculates the time remaining for a download. The default method is based on the current download speed for this file, whereas the advanced method takes the average speed since adding this file into account. The advanced calculation may give false results if the download has been added in a version prior v.43a.

Start next paused file when a file completes
If a file is completed and you have paused files in your download list, one of them is automatically resumed. Pausing files or adding files in paused mode together with this function will care for a constant amount of sources (for normal DSL it should not go far above 3000) without clogging eMule because of too many sources.

o prefer same category
This option is only available if Start next paused file when a file completes is used. If Categories are used, eMule will try to resume a file from the same category as the finished one was.

o only in same category
This will enforce that only a file in the same category as the finished one will be resumed.

Video Player
If this box is empty, eMule will use the default media player associated with this filetype when previewing video files. If a path to another player is specified here, this one will be used instead. Usually most media players need a temporary file as they do not handle the gaps in unfinished files very well. If a default player is used the box Create backup to preview should be checked. A video player which does not need this temporary file is VLC - VideoLAN Client which could be used to preview files from eMule instead of the default player. For more information also see Previewing Files.

Applies to version: .44a +
Last update on: 2004-09-11 by Monk
12.09.2004 7:30


114

 Notification

Notifications are triggered on specific events, displaying a neat little graphic as a pop-up in lower right corner of the screen.
This pop-up will even appear when watching movies or playing games.

Msg Popup
o Use sound
When this box is check a sound file has to be entered in the field below, which is played when an event matches.

Pop out when
o Log entry added
Everything that will appear in Servers -> Log will be displayed as pop up

o Chat session started
On start of a new session in Messages

o Chat messages recieved
This event is triggered when a new message is recived. The [image] -icon also alerts of this

o Download added or finished
Whenever a download is finished or added via web/irc link or search

o New eMule version detected
A notification pops up if eMule detects a new version which can be downloaded on www.emule-project.net

o Urgent: Out of disk space, server connection lost
If disk space is used up, download status will be set to pause or in the case of a already completed file errorious.

Applies to version: .27a +
Last update on: 2003-03-12 by Monk
29.02.2004 14:43


115

 Statistics

Graphs
o Update delay
Determines how often the graphs are refreshed. Setting this value too low, i.e. very fast update, can have an impact on CPU usage

o Time for average graph
By default the average graphs are calculated from the values of the last 5 minutes. This is a long term performance indicator.

o Colors
Choose which part of the statistic display to modify from the drop down list then use the color selector to apply the color. Even the color of the little speed indicator next to eMule's tray icon can be changed.

o Connections Statistics Y-Axis Scale
In the Stats tab directly below the details statistic tree is a graph indicating the currently active connections and number of up- and downloads. This graph is usually scaled from 0 to 100 but this setting allows to change it, thus increasing or decreasing the resolution of the graph.

o Active Connections Ratio
Depending on the internet connections and settings the number of active connections is very dynamic but usually above 100. To display the entire connections graph this setting can be used to scale it down. A factor of e.g. 1 : 4 will divide the number of active connections by 4 then displaying this value as the graph.

Hint:
To increase the resolution for number of up- and downloads and still display the complete connections graph the above two settings are useful. Decreasing Connections Statistics Y-Axis Scale will increase resolution for the Up-/Download graph and increasing the Active Connections Ratio will make sure that the graph is still displayed.

Statistic Tree
o Update delay
Refresh interval of the detailed statistic list. See Update delay in Graphs for a note on CPU usage.

Applies to version: .29a +
Last update on: 2003-06-03 by Monk

29.02.2004 14:45


116

 IRC

Server
The default and official IRC network is irc.freshirc.de.

Nick
Specifies a different nick name for IRC than the one entered in General tab. Please use your own nick and not default when entering an IRC chan!

Channel list
o Play sound events
This function is known from the mIRC client. It can be used to play sound files which more users in a channel may have. Sounds for the IRC must be placed in eMule's installation folder in the subfolder .\Sounds\IRC. Only *.wav files can be used.
In the channel the command /sound soundfile.wav can be issued to play it for the entire chan. The command /sound nickname soundfile.wav will play it for the given nick name only.

Warning:
This feature may severly annoy other users, especially in large channels. Use with care or you may be heading for a kick or ban.

o Use channel list filter
Filters can either be a Name or a certain number of Users. The channel list will only show channels which have a matching Name or more than the given number of Users.

Perform
o Use perform string on connect
This options allows a specific actions to be carried out on connect. Useful might be the /join [#channel name] or the /ns identify [pwd] command. Multiple commands can be chained using |.

Example:
/ns identify [pwd] | /join #emule

Misc Options
o Connect to help channels
With this option checked eMule automatically joins the official IRC help channels.

o Add timestamp to messages
The current time will be displayed in front of each irc message

o Load server channel list on connect
Automatically displays all available channels of the connected server as a separate tab

o Ignore Info Messages
No channel information like joins and quits are displayed. Makes the chat look cleaner.

o Ignore eMule protocol messages
Similar to the one above to ignore eMule Protocol Messages in the channel.

o Allow users to add you as a friend
The eMule IRC chat allows to add friends directly from the nick list using the right mouse button. Removing the check will deny the request to be added to the friends list. The users trying to add the friend will receive no message when denied.

o Accept eD2k links in IRC (Use this with caution)
If enabled this function will automatically add all posted eD2k links in a chatroom directly to the downloads list.
To avoid gathering unwanted links it should be used together with the From friends only option. If this one is also turned on links will only be accepted from users who are added as friends in eMule's Message Window

Applies to version: .43a +
 Last update on: 2004-07-24 by Monk

01.08.2004 11:01


117

 Scheduler

The scheduler is used to tweak eMule's settings regarding a set time and week day for the change. It could be used for raising up- and download during night time whereas the bandwidth remains free for other applications during working time.

The scheduler allows to create action profiles with one or more actions to perform at a set time or weekday.
The first list box shows the created Profiles with Title, Days to perform the actions and its Start Time. A chosen profile shows the defined actions and time settings in the Details area.

o enabled
Activates the whole scheduler

o Remove
Deletes the high-lighted action profile

o New
Creates a new action profile. New profiles are automatically displayed in the Details view to make the appropriate settings.

Details
This area shows the current settings and actions for the chosen action profile.

o enabled
This checkbox activates the chosen profile. One or more profiles can be activated at any time.

o Title
Title or description of the profile.

o Time
Actions can be performed daily or only on certain days of the week. Each action also has to have a Starting Time and Ending Time.
If no action is valid at a given time, eMule automatically uses the default settings from the other Preferences dialogs.

Creating Actions in a Profile
First a new profile has to be created by the pressing the New button. After entering a Title and the Starting and Ending Time for the profile new actions are created by the right mouse button menu in the Action list.

o Add
Creates a new action in the chosen profile. After choosing which type of action to create a message pops ups up. Set the appropriate value for the action to change:

> | Upload Limit Defines the maximum upload bandwidth in kB/s eMule may use.
> | Download Limit Sets the maximum download bandwidth for eMule. Value also in kB/s
> | Limit sources Changes the number of sources allowed (Hard Limit) for a download.
> | Limit connections/5secs Changes the number of new connections created in 5 seconds. This value may have a serious impact on eMule's performance. See Preferences -> Extended for details.
> | Max. Connections Overrides the maximum number of connections from Preferences -> Connections.
> | Cat: Stop Downloads This actions stops all downloads in the chosen Category.
> | Cat: Resume Downloads Resumes all stopped downloads in the given Category

All changes in a profile's settings must be confirmed by the Apply button.

o Edit
Changes the value for the selected action

o Remove
Deletes the chosen action.

Applies to version: .28a +
Last update on: 2003-04-02 , Monk
29.02.2004 14:49


118

 Webinterface

The Webinterface offers a remote access to eMule. Read the topic on the Webinterface in the Feature Category of this FAQ to get more information.

Templates:
For the Webinterface to work a file called eMule.tmpl has to be present. This file contains the layout and design of the webinterface. This file is either distributed with the eMule release or can be downloaded on www.emule-project.net.
The image resources have to be placed in the folder Webserver in eMule's installation directory.

General

o Enable
Check this box to activate the Webinterface. After turning on this option the template which generates the web interface has to be reloaded by pressing the Reload Template button. If no valid eMule.tmpl is found the error message Can't load templates: Can't open file \...\eMule.tmpl will be displayed.
Do not enable the webserver unless you use this feature. Running servers are a potential security risk.

o Gzip compression
Will use compression to save bandwidth when sending webinterface related traffic.

o Port
This determines the port the webserver will be running on. Default is 4711 and there is usually no need to change it. This port is part of the address to access the web interface.
If the computer that is trying to access the webserver has this port blocked by a firewall or a proxy server you can change the port to 80 as this is the standard port to surf the internet and thus is rarely blocked.
If a router is used this port has to be forwarded.

o Template
Usually the template file *.tmpl is in eMule's installation folder. The ... button allows to change the path to this file easily.

Admin
Sets the password to access the Webinterface. It is important to set a proper password or anyone may access your eMule via the web interface. An entered password is displayed as 6 ***. There is no default password.

Guest

o Enable
Unlike the admin who has access to eMule's controls a Guest may only view the settings and lists. He has no rights to change anything. If Guest login is not needed it should be disabled.

o Password
Defines a password to restrict access to the Guest interface. Also no default password.

Note:
Instead of displaying the chosen list the webserver may pop up a download dialog when using Microsoft's Internet Explorer. To prevent this the options Use HTTP 1.1 and Use HTTP 1.1 through proxy connections must be checked in Extras -> Tools -> Internet Options -> Advanced : HTTP 1.1 settings

MobileMule
MubileMule is an interface which can be connected by any java-able cell phone. Similar to the webinterface it allows to remote control eMule via a mobile phone. For more information visit the MobileMule Page http://mobil.emule-project.net/.

o Enable MobileMule
Allows accessing eMule with a java cell phone.

o Password
No default password is entered. For security reasons there should always be a password set when the interface is enabled.

o Port
Sets the port to access the MobileMule interface. If the machine eMule is running on is behind a router or firewall this port has to be forwarded / opened or connection will not be possible.

Applies to version: .42a +
Last update on: 2004-02-27 , Monk

29.02.2004 14:51


119

 Security

IP-Filter
IP-Filters are used to restrict connections to and from other clients. All IP ranges that are entered in the ipfilter.dat file cannot connect to eMule nor can eMule connect to them. This file can be edited via the Edit Button and is saved in eMule's install folder. For more information on filtering IP see the topic IP Filters of this FAQ.
eMule has to Reload the ipfilter.dat file before any changes apply.

o Filterlevel
Each entry of the ipfilter.dat has an access level assigned. This value describes how trustworthy this entry is. High values (default 128+) are considered secure whereas lower values are to be blocked. The Filterlevel determines the limit of blocking. Each entry in ipfiletr.dat which has an access lower than the set Filterlevel will be denied connection to eMule. The default value should not be changed.

o Filter Servers too
The IP-Filter rules are usually only valid for other clients. This option will extend the filtering to servers as well.

o Update from URL
Entering a link to a filter file and pressing Load will add the found IPs to eMule's ipfilter.dat. See the IP Filter chapter for links and more information

Messages
Unwanted messages can be blocked by entering them in this filed. If the text matches no messages will be displayed. Multiple messages may be chained using | as separator.

o Accept from friends only
All messages except from users added to the friends list will be blocked.

o Accept from valid clients only
This setting makes sure, that messages are only accepted, if the sender client is valid and does not appear to be a fake. This setting should be turned on.

o Advanced Spam Filter
The Advanced Spam Filter will check every incoming message. If any of the following filter criteria is met, the sender of the message will be ignored. A spam ignore will last for the current session only.
> | A webadress or URL is sent on first contact
> | The user already sent 5 messages without receiving a reply

Users on the friends list will never be marked as spammer.

Comment
This functions works like the message block above but is applied to file comments

Note:
File comments should help other users to judge the quality of a download. They are not intend to talk about the weather or for advertisements of any sort. Please leave proper comments.

Miscellaneous
o Use secure identification
It is recommended to use the secure user identification. For more information on this topic see here.

o Run eMule as unpriviledged User
This option is only available in the Win NT series (2k, XP, 2003) and allows eMule to profit from the tighter security these systems provide.
Usually a user is logged on to his machine with an Administrator account. This account type allows him and all executed software full control over the system. In this case also all malicious code executed will have its full bad effect.
Running eMule as unprivileged user will create an own user account in the operating system called emule_secure and sets the permissions for full access to the folders it needs (installation folder, temp and incoming folders) for this special user. Otherwise this account is heavily restricted and denies access to other parts of the system. eMule starts itself under this user account making sure that any malicious code which may be injected has no rights on the system, thus not being able to do any harm. This is a preventive measure in case of any vulnerable code is found which could be exploited.
Notes:
o | eMule cares for the file access it needs. Further security can be achieved by deliberately restricting file access to other folder or entire drives. Restricting file access is only possible with NTFS but not with FAT
o | The separate account offers the full possibilities of control mechanisms in modern operating systems like disk quotas etc.
o | A bug in Windows XP prevents any visual styles from working when eMule is run in this mode. The GUI will look like standard Win98. Windows XP SP2 seems to solve this problem.
o | This setting will not provide any anonymity in the network but makes the system eMule runs on more resistant to any possible outside attack.

Applies to Version: .42f +
Last Update: 2003-06-20 by Monk

01.05.2004 18:38


120

 Extended

Max. new Connections per 5 seconds
This is the number of new connections eMule opens during 5 seconds. Default is 20.

Important:
> | Messing with this setting can cause blue screens, hung routers and the inability to browse the web. Also Up- and Download may suffer with wrong settings here.
> | You may slightly increase this setting when running eMule on high bandwidth connections like Tx or LAN.

Max. Half Open Connections
This setting became necessary with the connection throttling of Windows XP SP2. This update in XP will only allow 10 half open connections and then starts parking further connections in a queue which is only slowly processed. This leads to timeout and other undisired effects in eMule.
If eMule is running on XP SP2 do not set this value any higher than 9. Although there are patches to increase this hardcoded value in XP, it is not recommended to patch such critical parts in Windows. The only effect this setting does have is that eMule acquires sources a bit slower right after startup. This will subside after the sources have been found.
In other operating systems like Windows 2000 or the obsolete Windows 80/ME set this value to 50.

Autotake eD2k Links only during runtime
This option only associates the eD2k link format when eMule is actually up. When eMule is closed the association is deleted to allow uninterrupted working of other eD2k clients.

Open/close ports on Win XP firewall when starting/exiting eMule
eMule is able to automatically open its needed ports in the internal Windows XP firewall. This setting will further increase security by not keeping the ports open after eMule is closed and to open them up again when it is started. This setting is only available in Windows XP and only for the internal firewall, not any third party products. This option does not work correctly in the current Win XP Sp2 RC releases.

Use Credit System (Reward Uploaders)
See the chapter Credit System for more information first. It is strongly recommended to leave the Credit System turned on as it will deter leechers from harming the network.
The reason for this option are:
> | Releasers can now make sure that no other file will take precedence over their release files by turning off this option.
> | A mixed network will better resist possible exploits of one system.
> | The balance between rare and popular files will increase.

Filter server and client LAN IPs
Sources containing IPs of the private IP classes A (10.0.0.0 - 10.255.255.255), B (172.16.0.0 - 172.31.255.255), C (192.168.0.0 - 192.168.255.255), local host (127.0.0.0 to 127.255.255.254) and all IPs starting with null (0.x.x.x) are not valid in the internet. Such sources received by client to client source exchange or by servers are dropped when this filter is activated.

Note:
Running eMule in a local network (LAN) requires this option be turned off or eMule will not be able to find any sources in this network.

Show more controls (advanced mode controls)
This options activates even more functions in eMule which are usually not needed for running it.

o Show Meta Data
This is a command in the right click menu of a download in the Transfer window. It shows additional information which may have been entered for this file like mp3 ID tag or Author, Year etc.

o Source handling (A4AF - Ask For Another File)
See the eMule's feature section Advanced Source Handling for more details on this option.

Disable A4AF checks to save CPU
This will turn off any source handling as described in the Advanced Source Handling chapter. Only when a download is canceled, potential A4AF sources are redistributed according to the priorities.

Check Diskspace (min. free diskspace [MB])
The size of eMule's temporary download files increases dynamically on demand. The Check Diskspace option ensures that the current downloads can be entirely downloaded and completed. Downloads which are too big for the current free disk space get paused so that other downloads can be completed.
If you provide a value for the min. free diskspace eMule's behaviour changes. Now all files are downloaded until the limit for free disk space is reached.
When free disk space increases the paused downloads will restart automatically.

Hostname for own eD2k Links
In the shared files main tab eD2k links with the current IP as source can be created. Entering a hostname in this filed allows to create such links with the hostname instead of the IP. The advantage of this link is that it is still valid should your IP change.
For more information on dynamic hostnames see the Webinterface chapter.

Disable downloading from PeerCache
PeerCache is a system that will cache downloads in a completely anonymous way at the ISP level. This will decrease the amount of traffic an ISP has to cope with by buffering parts of downloads in its own system and so also providing better download speeds for the users. ISPs have to support this feature to be effective.

Save logs to disk
The output of the two log windows of the Server tab - Log and Debug - can be saved to disk by turning on the corresponding option. They will be save as eMule.log or eMule_Debug.log in eMule's installation folder.

Verbose (additional program feedback)
If Verbose mode is turned on an additional Debug tab is displayed in the Server window. The information shown therein are for development only and no additional support on these will be provided. This option causes a greater CPU and memory load. Not recommended for normal operation.
The Log Level option controls which log messages are shown. Level 5 means all verbose messages whereas level 1 shows only the most important one. If you want to know the importance the various messages have look it up in eMule's source code ;)

Safe .met / .dat file writing
On newer operating systems using NTFS as file system there is usually no need to change this option. If downloads are reproducibly lost on crashes or eMule shut downs the safer method should be tried.
Depending on the hardware used, this option may notably increase disk activity / system load or prolong eMule's shut down!

o On shutdown
eMule will use extra safety measures to commit the .met and .dat files to disk on application exit. This may prolong the time needed for shut down.

o Always
The safety measures are used on every write access to these files.

Server Connection Refresh Interval
There have been cases reported, that eMule loses the server connection in regular intervals when operating behind a router or network configurations which use NAT - Network Address Translation.
Routers often have a timeout for these NATed connections after which the router declares the connection for dead and closes it. When this happens and eMule tries to recheck its server, a full reconnect is needed because the old one has been removed by the router.
Should this issue occur, look up the value for the NAT timeout in your router's settings and enter a slightly lower value into the Server Connection Refresh Interval field. A value of 0 means eMule handles this and there is usually no need to change that!
Do not mess this this setting unless you have a router or a more complicated network setup. This may get you banned from the servers if the value is too low.

Upload Speed Sense (USS)
USS is a function to monitor the ping times of the connection and to automatically adjust eMule's upload according to this ping value. This ensures that the connection never cloggs and will try to keep surfing and online gaming fluid. It is recommended to keep the default settings.

o Find best upload limit automatically
Activates USS

o Lowest allowed upload speed
This is the minimum upload USS must keep. Recommended is at least 50% of your upload capacity

o Ping Tolerance (% of lowest ping)
A inital average ping is detertmined for the connection when eMule starts. USS will not allow a ping increase over the inital ping times the entered multiplier, e.g. an inital ping of 50 ms and 800% ping tolerance will result in a maintained maximum ping of 400 ms.

o Ping Tolerance (ms)
Instead of calculating the maximum allowed ping by a % modifier also a value in milliseconds can be specified. See next setting.

o Method for ping tolerance
Chooses the preferred method for determining the maximum allowed ping. Either the percentage or the millisecond modifier is used.

o Going up / down slowness
These two values describe how fast the upload limit is adjusted to stay within the ping tolerance. Setting wrong values here will collapse the connection. Keep default!

o Maximum number of pings for average
Sets the number of pings needed to calculate the average response time.

File Buffer Size
Some system may display a "stuttering" when eMule flushes its file buffers. Lowering the buffer size may help in this case but will result in a higher disk activity caused by eMule as data is written to disk more frequently. Setting the buffer size too low can severely reduce eMule's performance.
Increasing the buffer will reduce disk activity but at the risk of higher data loss should problems occur.

Queue Size
For the Credit System in eMule to work properly the queue size is very important. If a client has a full queue another client with a high credit rating will have no chance to enter the queue to spend his credits. So the larger the queue is, the better and smoother credit system will work. Clients with high credits will advance in long queues fast enough to get their share. Also, queue waiting time is not reduced when reconnecting due to IP change or similar. Time until reconnected may not exceed 1 hour or the queue position will be lost.

Important:
A larger queue does not result in a larger overhead for managing this queue. Neither the number of connections nor the connection overhead will be increased by a larger queue. Larger queues may use more memory.

Applies to version: .44a +
Last update on: 2004-09-11 by Monk
12.09.2004 7:36


121

 Preferences.ini

All of eMule's settings are stored in the preferences.ini file. The important options are easily accessible through the Preferences dialog but
the preferences.ini file gives access to some more. To access those the preferences.ini file has to be opened in an editor and changed manually. Working in *.ini files is for advanced users as wrong entries quickly produce unwanted effects. If an entry does not exist per default it will have to be added manually in the correct section of the file. Close eMule before editing.
The default values are given first in each header.
Section: [emule]
o | TxtEditor=notepad.exe
The default program for editing the Webservices and IPFilter.dat may be entered here. Provide the complete path to the new executable if not using the default notpad.exe.
o | DateTimeFormat=%A, %x, %X
This string defines how date and time is displayed in eMule. See this msn article for a detailed description of all possible formatting codes.
o | MaxLogBuff=64 / 128 (v0.30a+)
Defines the amount of system memory eMule uses to display the logs. For Windows 98 / ME a default of 64 kB is reserved, for Win 2k/XP it is 128 kB. In Win98/ME the buffer may not be larger than 64 kB. The logs are rotating, i.e. if the buffer is filled up to its limit an old message is purged when a new one arrives (FIFO). This setting replaces MaxLogMessages from v0.29.
o | MaxChatHistoryLines=100
Defines the maximum number of lines saved in the history of the irc / messages. After this value is reached the oldest message is purged on new entry (FIFO - First In First Out).
o | ExtractMetaData=2/1/0
Controls, how MetaData will be read from files. (v0.30a+)
0: disabled
1: enabled for MP3 and AVI files
2: default, enable for MP3, AVI, MPEG and other files
o | ServerUDPPort=65535

Normally the local port for asking servers for sources or searching files on them is randomly chosen (see topic ports #6). If eMule is run on a machine in a more complex network, especially when proxies are used, it may be necessary to fix this port to a defined value or to deactivate it at all. Disabling this port means that eMule will no longer be able to update the status of the servers in its server list and will also not be able to receive sources from them nor do a global search. Exempt from this is the server eMule is actually connected to. Usually the default setting should not be changed.
Possible values for ServerUDPPort are:

0 | Disabled
1 - 65534 | fixed local UDP port
65535 | random port (default)
o | PreviewSmallBlocks=0/1
This function should be only activated (=1) when using VLC - VideoLAN Client to preview files. It allows to preview multimedia files when at least 16 kB data for .mpeg files or 256 kB data for all other multimedia content (.avi, CD-Images with multimedia content) has been downloaded. For more information see Preferences -> Files -> Video Player and the topic Previewing Files. Using this option the Create backup for preview setting has to be deactivated in the Video Player dialog.
o | RestoreLastMainWndDlg=0/1
If RestoreLastMainWndDlg=1 is added to the preferences.ini, eMule remembers which of the main windows (Kademlia, Server, Transfer, was open, when before application exit and restores it.
o | RestoreLastLogPane=0/1
Same setting as RestoreLastMainWndDlg but remember which of the log panes (Log, Verbose) has been used the last session.
o | RemoveFilesToBin=1/0
This setting affects the Delete From Disk function in the right click menu of the Shared Files main window. If set to disabled (=0) then files will be permanently deleted from disk without moving them to the recycle bin.
o | PreviewCopiedArchives=1/0
When this option is disabled (=0), eMule will use a new preview method which is faster and uses less disk space in the temporary folder. Feedbacks for this new version are welcome.
o | ShowActiveDownloadsBold=0/1
Will print the text of currently downloading files in bold letters.

Section: [Perflog]
o | File=D:\Path\to\datafile\perflog.csv
If MRTG is used to graph eMule's performance, this entry denotes the path and filename to save the performance data in. Usually this is set by the MuleMRTG Installer and there is no need to change it. If changed MuleMRTG will have to be reinstalled.
o | Mode=1
Sets the sampling mode for data collection. If used with MuleMRTG it must be set to 1.

12.09.2004 7:22


123

 General

All ports listed here have to be opened in the firewall’s rule set. As most Windows firewalls are application based you can save yourself some trouble by adding a rule which allows the eMule.exe all UPD,TCP traffic on all ports in all directions. This will not compromise your security, as no exploits of eMule are known so far.

Notes:
- ZoneAlarm is reported to cause problems with eMule. It is not recommended. Nice and free firewalls are Kerio Personal Firewall and Agnitum Outpost

- I'll add some more configuration examples as time allows. If you want to contribute then write a nice guide on how to use your favoured firewall. Add a few nice screenshots and send it to Monk@emule-project.net

02.05.2004 15:17


124

 WindowsXP Firewall

The Windows XP firewall is generally not recommended as it isa very basic form of firewall. If you want to use it anyway these steps are necessary:

1. | Open eMule
2. | Click Preferences > Connection
3. | Write down the client port value (default 4662)
4. | Also note the UDP port value (default 4672)
5. | Close eMule and your internet connection
6. | In On Windows XP click Start, and then click My Network Places.
7. | Go to Network Tasks, click View Network Connections. (Alternatively, you can right-click My Network Places and click Properties.)
8. | Right-click the connection you use for the Internet and choose Properties
9. Click the Advanced tab, and then click Settings.
If the Settings button is unavailable, ICF is not enabled on this connection and you do not need to open any ports (they are all already open).
10. | Click Add to open a new port.
11. | Type a name in the Description box, for example, "eMule : TCP Incoming".
12. | Type 127.0.0.1 in the Name or IP address of the computer hosting this service on your network box. You can specify the IP address of an internal computer; however, in most cases, you use 127.0.0.1
13. | Type the client port you wrote down in step #3 in the External port and Internal port boxes.
14. | Choose TCP, and then click OK.
15. | Click Add to open a new port again.
16. | This time choose a name like "eMule : UDP Incoming"
17. | see #12
18. | Now External port and Internal port is the value you noted in step #4.
19. | Choose UDP, and click OK.
If you change your client port later, you need to reconfigure the rule above on your firewall.

For additional information, click the article numbers below to view the articles in the Microsoft Knowledge Base:

Q308127 How to Manually Open Ports in Internet Connection Firewall in Windows XP
Q283673 How to Enable or Disable the Personal Firewall Feature in Windows XP
Q307554 Programs Require Manual Port Configurations with Internet Connection Firewall

(this nice ICF how to was adopted from -nRoK-. Thanks)

23.07.2003 11:18


125

 General

Without proper configuration you will have a low ID when using a router. A router works like a shield to the network behind it, masquerading the IP addresses of the computers in the LAN. When another client tries to establish a connection to your eMule it only sees the IP of the router but not the actual IP of the computer eMule is running on. To prevent this all ports in the list that have the incoming direction – port 4662, 4711 TCP and port 4672 UDP – have to be forwarded.
See your router's manual. Keywords to start are port forwarding, DMZ – Demilitarized Zone, Filters and Rules.
Many routers also have built in firewalls so be sure to set the appropriate ports (see Firewall) there, too.

Note:
When using a router in a network the option DHCP - Dynamic Host Configuration Protocol in the router should be turned off. Assign static IPs to each client in the network. This can be done in Window's Network Connections -> LAN Connection -> Properties -> TCP/IP. Deactivate the automatic IP assignment and enter an IP in the range of 192.168.xxx.xxx. Different types of router have different home IP ranges, this is noted in the routers manual.
After entering a valid IP the Subnet Mask field automatically changes to 255.255.255.0. Last step is to enter your router's IP as Standard Gateway.

If you care to help other users and know how to handle your type of router, write a little guide and send it to Monk@emule-project.net

Note:
If your typ of router is not listed have a look at the examples anyway as the configuration works quite similar among the different types of routers.

Last update on: 2003-03-22 by Monk

23.07.2003 11:19


126

 Solwise SAR-7x5 + Allnet ALL129

Note:
This assumes that you have the firewall disabled, and run a NAT configuration.

First navigate to your routers web configuration page in your browser. It defaults to http://192.168.7.1

Now click on Advanced Configuration on the left.

Press Security/NAT on the list of options that pops up.

Now on the page that loads, look for Security Interfaces.

Click Advanced NAT Configuration below the ppp-0 connection. A screen will load, look for Reserved Mappings.

In this section press Add Reserved Mapping.

Now comes the tricky part. Follow this screenshot and press Add Reserved Mapping when done.
You need to do this twice, once for port 4662 TCP and once for port 4672 UDP.

Important:
You must enter the IP of the machine eMule is running on. To verify your IP go to Windows Start Menu -> Settings -> Network Connection. Highlight your LAN connection click right mouse button and click Properties. Choose Internet protocol (TCP/IP) and click Properties. The dialogue shows your current IP address

Once you have done this simply save your configuration by pressing System on the left hand side menu , then Save config.

You have successfully configured your SAR7x5 router to use eMule.

This nice guide was done by aldo. Thanks a lot.

21.03.2004 15:17


127

 Lucent CellPipe 20A-GX-E
Follow these simple steps to configure your Lucent CellPipe for eMule. This setup assumes you have a PPPOE connection like DSL running.
Start a telnet session with your routers IP. To do so
 | a) Use the Windows Hyper Terminal and type in a Name (does not matter which) for the new session, choose TCP/IP (Winsock) as connection type then enter your router's IP as the host address
 | or
 | b) Go to Start -> Run -> telnet router's IP
In the telent sessions that starts enter these commands each on a single line:
 | pat addpatin pppoe 4662/tcp client's IP pat addpatin pppoe 4672/udp client's IP save
Router's IP is the IP address of your CellPipe router and client's IP is the IP address of your computer running eMule.

Many thanks to Jarek for this how to.

23.07.2003 11:23


128

 SMC Barricade 7004

Content

Content | A list of steps in this guide
Foreword | Some things about this guide you might want to know
Login | Accessing your router-configuration
IP | Finding out your network-IP
Virtual Server | Configuration Step One
Special Application | Configuration Step Two
The End | Some words
FAQ | Frequently asked Questions

Foreword

This is Version 2 of my SMC guide that should be able to explain how to set up nearly every SMC router I know for eMule.
Here I'd like to thank those who send me tipps and advices etc. but I'm sorry but I lost every single email I ever got before 22.02.2004 due to a wrecked HDD.
The guide was written for my SMC Barricade 7004ABR (eu) with the firmware V1.42.012, but it is usable for many SMC routers as well as some copys of those:

  • SMC Barricade 7004 ABR
  • SMC Barricade 7004 ABR v2 (the Virtual Server looks a little different, but you've got to enter the same stuff) (Thx to Tilube)
  • SMC Barricade 7004 VBR (Thx to Ulf)

Note: This list was once bigger, but I lost all the mails in which some nice people told me, that their router has the same configuration. If you know your Router has the same config,
please send a short eMail to theurmel@arcor.de, thanks. If you want to include screeshots, please use a lossless compression format like PNG or GIF.

Login

Accessing the configuration of your SMC Barricade is very easy. You've just got to enter its IP in your browser, and hit ENTER.
The standart IP is 192.168.2.1, so you would have to enter http://192.168.2.1/ into your browser, or just click the link.
You should now see a window like this:
Login Screen
Now, you've only got to enter your password into the password box and hit the [image] -button.

IP

To find out your IP, you've now got to click on Status. You should now see a little frame in the middle of your screen titled "Security Log" looking like this:
2004/03/06 10:32:38 192.168.2.30 login successful
If you don't see a line like this at once, scroll the frame down to the bottom. The entry we are looking for should be among the latest ones.
In my example here i've got this line:
2004/03/06 10:32:38 192.168.2.30 login successful
so my IP is 192.168.2.30. Remember it or write it down somewhere so we can go on.

Virtual Server

Now click on Setup so we can proceed.
In the left of your screen, a list of subjects has now appeared. Under Advanced Settings you should find a point named Virtual Server. Click it.
If you have got a SMC Barricade 7004 ABR v2, you'll find it under NAT.
You should now have a list in front of you. Here, you'll have to enter the following things:
Virtual Server
As in my example, I used my IP 192.168.2.30. If your IP is different (and that's very likely), you'll have to enter the last segment (in my case 30) of your IP into the Private IP field.
Also, I use the default Client-Port 4662 and UDP-Port 4672. If you have set a different port, please look them up in your eMule-Configuration.
If you do not wish to use the eMule Webserver, then you don't have to enter the 4711 port line. If you do use it, please check wether the port is correct in your Webinterface-Configuration.

Now, click on the Enter -Button to access the Special Application Menue.

Special Application

Here, you've got to enter the following:
Special Application
I use the default Client-Port 4662 and UDP-Port 4672. If you have set a different port, please look them up in your eMule-Configuration.
If you do not wish to use the eMule Webserver, then you don't have to enter the 4711 port. If you do, please check wether the port is correct in your Webinterface-Configuration.

Just one more click on the Enter -Button and ont Logout -Button.

The End

Well, this it is. You should now get a HighID by every server and Open status in Kademlia.
If you've still got any questions that are not answered in the FAQ, feel free to mail me at theurmel@arcor.de.
I cannot guarantee to answer the mails, but I try to. And please do not send me mails in any other language than german or english (if you really have to, french is also OK, but I can write it very well so I'll respond in english).

FAQ

"I configured everything as described and still got a LowID. What can I do?"
Please recheck wether the Clientport is the one set in your eMule-Configuration, and that you've got the correct ports entered in the Virtual Server and the Special Application configuration.
If everything is correct, try to enable Safe Connect in your eMule's Server Configuration.
And keep in mind, you've always got to reconnect to a server if you want to check if you've still got a LowID.

"I use eMule on two computers connected to my router, but although it is set up correctly to your guide, one of my eMules gets a LowID."
First of all, I do absolutely recommend to use only one eMule per network because it's less trouble for you and less overhead for the servers. Also, you would have your Uploadcapacy divided between two eMules so that if you've got an upstream below 20kb/sec, you'll have the ratio activated, thus reducing your maximal Download. I recommend you to use the webserver instead of the second eMule.
If you still want to use two eMules, you've got to assign them diffenrent ports (Like eMule1: Clientport 4662, UDPport 4672 - eMule2: Clientport 3662, UDPport 3672), forward these to the correct computer in the Virtual Server, and enter the ports in the Special Application configuration.

29.07.2004 12:57


129

 Linksys BEFSR41

This guide assumes you have a Linksys BEFSR41 router. It will be fairly similar if you have another Linksys router like the 'wireless' or 'firewall' (BEFSX41) version but I'm not sure because I don't have these.

I'm running Windows XP Pro, but these instructions work fine with XP Home too. Windows98 users will want to look at the alternate instructions. The first two alternatives describe how to configure the router without using DHCP. Using DHCP sometimes makes things messy but Linksys offers a way to keep DHCP via Port Triggering

The aim of the guide is to show you how to setup your Linksys router so that you can use eMule. There are two ways to do this, either as below using UPnP, or by using a browser. These instructions are long and drawn out on purpose, hopefully so you don't get stuck! Realistically the whole thing is really very easy once you get the hang of it, so please don't be too intimidated by how long these instructions are.

Security Concerns with UPnP

There are some serious security issues with Universal Plug and Play. You should read about them here.
Thanks to Monk for letting me know about this.

To check your security you might want to try some of the tests at http://www.pcflank.com/ or this test at http://www.dslreports.com/scan/

If after reading / testing you decide to go ahead and disable UPnP then you'll need to follow my

alternate instructions for setting up port forwarding without UPnP.

Or, if you decide that you are perfectly secure then continue below.

Windows XP UPnP instructions

  1. The first step is to make sure you have a fairly recent firmware version for your router. Firmware is like the internal software inside the router. You can upgrade to the latest version by visiting the Linksys download page. Select your router from the drop down list, select the firmware link, save the file and follow the instructions. They make it fairly easy and straightforward to do, and it is quick.

  2. Once you've done the previous step... In Windows, click start>settings>control panel>network connections to open this page:

    Compare what you see to my picture, if you have the entry that says Internet Gateway enabled, you already have UPnP installed and this whole process will be easier. Windows XP should have already set all this up if you bought your router and it already had firmware version 1.42 (?) or later installed. If you do anyway then skip ahead to step number 4 below.

  3. To install UPnP:

    1. Click Start, click Control Panel, and then click Add or Remove Programs.

    2. In the Add or Remove Programs dialog box, click Add/Remove Windows Components.

    3. In the Windows Components Wizard, click Networking Services, click Details, and then select the 'Universal Plug and Play' check box. You should also see 'Internet Gateway Device Discovery and Control Client' listed, put a tick in the check box for this also - as I've done below.

    4. Click OK, and then click Next in the Windows Components Wizard. You may need to provide your Windows XP installation CD.

      ( I found this info at http://www.microsoft.com/windowsxp/expertzone/columns/crawford/02july22.asp)

    5. Using your browser, go to http://192.168.1.1/Passwd.htm and, as shown in the picture below, make sure that 'UPnP Services' are enabled:

    6. Click Start>Settings>Network Connections. Right click on 'Local Area Connection'. Select 'Properties'. A small window appears. At the top click on 'Advanced'. Make sure that the XP firewall is turned off as in the picture below:

    7. Now check back to step 2 above to make sure you have the UPnP working right. It seems to take a while for the internet gateway entry to appear so be patient, wait a couple of minutes perhaps and check again if it isn't showing when you first look, refreshing the window often makes it miraculously appear.

  4. Now that you have UPnP up and running setting up port forwarding is really quite simple...

    The first thing to do is to highlight the entry for the local area connection in the network connections page just like i'm doing in the picture below:

    On the left side in the details section you should now see your router assigned ip address as shown in the picture below:

    ...in this example it is 192.168.1.100, make a mental note of whatever yours happens to be.
  5. Back on the main section of the page, right click on 'Internet Connection' and then select 'Properties' from the menu that appears.

    You'll see this window:

    Click on settings, and then 'Add'. This is where you will specify which ports the router needs to forward to make eMule work. Fill in the blanks as below, except in the IP address field substitute your own router assigned IP address that you memorized from the previous step. The 'Description of Service' text field can be anything you like - it's just so you can identify it later... "eMule" works just fine:

  6. After clicking on 'OK' to save this new setting, click 'Add' once again to setup a second port forward. Once again fill in your own IP address, type "eMule" as the description of service, and copy the remaining details as they are shown below. Then click 'Ok' to save the settings:

  7. You'll notice that you now have two entries for eMule, as in the picture below:

    Click 'Ok' to save the settings you made and exit. That's pretty much all there is to it! You've told your router to forward incoming traffic to ports 4662 and 4672 on your computer. Run emule and everything should now work.

Windows98 / Alternate instructions / not using UPnP

There's another way of doing all this.
  1. Open up your web browser and type in the address: http://192.168.1.1 to access your router status pages. Enter your password, the username is an empty field on my machine and it doesn't seem to matter... you HAVE changed the default password right? If not then for your own sake read your linksys manual and do this now!

  2. Click on the DHCP tab at the top

    Then click on the button labelled 'DHCP Clients Table'. You'll see the window below appear:

    Look in the Client Hostname column, find your computer name and memorize the last three numbers of the IP address to the right of it. In this example the client hostname is 'Christopher', and the last three numbers of the IP address are 100. Once you've got those three numbers memorized then close the window.

  3. At the top of the screen, on the right hand side, click on the orange colored tab labelled 'Advanced'. You'll arrive on the 'filters' page - you don't want to do anything here, instead click on the second tab along labelled 'Forwarding'... and fill out the details as I have below. Except of course you need to fill out the last three numbers of your IP address that you memorized (it might well be 100 like mine is):

  4. At the bottom click on 'Apply' to save the settings you just typed in. Now your router is setup to forward incoming traffic to ports 4662, and 4672 on your computer. Close out the browser window, and run eMule, it should now work!

Configuration with DHCP via Port Triggering

  1. Open up your internet browser and type the IP Address of your router (default: 192.168.1.1). Enter in your password (default: admin - change it!). Click 'Advanced'. Click 'Forwarding'.
  2. In the Forwarding screen you will find the button Port Triggering. Click it and enter the configuration shown below. You can ignore the msn entry when configuring eMule.

  3. Press 'Apply'.This should now allow your router to forward eMule packets to your machine without the need for specific IP Addresses allowing for DHCP or multiple machines using eMule.

Big kudos to Violator for this very comprehensive guide. Thanks to ThRaShErUk for the Port Triggering how to.

02.05.2004 7:06


302

 Cisco 677/678
Follow these simple steps to configure your Cisco 677 or 678 Router for eMule. This setup assumes you have a PPPOE connection like DSL running and a static IP.
Start a telnet session with your routers IP. To do so
 | a) Use the Windows Hyper Terminal and type in a Name (does not matter which) for the new session, choose TCP/IP (Winsock) as connection type then enter your router's LAN IP (normally 10.0.0.1 or 192.168.0.1, but may differ) as the host address
 | or
 | b) Go to Start -> Run -> telnet router's LAN IP (normally 10.0.0.1 or 192.168.0.1, but may differ)
In the telnet sessions that starts enter these commands each on a single line:
 | your_password (Provided by your ISP, in rare cases cisco if not changed) enable your_password (Provided by your ISP, in rare cases cisco if not changed) set nat entry add LAN IP 4662 WAN IP 4662 tcp set nat entry add LAN IP 4672 WAN IP 4672 udp write reboot
WAN IP is the IP address you have on the internet (Router's external IP) and LAN IP is the IP address of your computer running eMule.
Note: If anyone knows how to setup this router for dynamically assigned IPs, please mail Monk

Many thanks to Fuxie - DK for this how to.
Last update on: 2003-21-02 by Monk

08.03.2004 4:51


122

 Ports

The following list shows the ports used by eMule when using it's default settings. If you change anything in Preferences -> Connection you will have to take the changes into account when configuring your firewall or router.

1) | Local Port: | 4662
 | Remote Port: | any
 | Protocol: | TCP
 | Direction: | incoming
 | Purpose: | Client Port / Connections from other clients, Client to Client Source Exchange
 | Note: | You can change this port in Preferences -> Connection -> Client Port This port has to be forwarded in a router. Changing this port in Preferences you must also change the forwarding in the router
2) | Local Port: | any
 | Remote Port: | 4662
 | Protocol: | TCP
 | Direction: | outgoing
 | Purpose: | Client Port / Connections to other clients, Client to Client Source Exchange
 | Note: | 4662 is the default port, but other clients may have different settings. Change the remote port to any when configuring a firewall
3) | Local Port: | 4672
 | Remote Port: | any
 | Protocol: | UDP
 | Direction: | incoming
 | Purpose: | Clients source asking / extended eMule protocol, Queue Rating, File Reask Ping
 | Note: | This port has to be forwarded in a router. Changing this port in Preferences you must also change the forwarding in the router. If you are not able to forward this port check the disable box in Preferences -> Connection -> UDP Port
4) | Local Port: | any
 | Remote Port: | 4672
 | Protocol: | UDP
 | Direction: | outgoing
 | Purpose: | Clients source asking / extended eMule protocol, Queue Rating, File Reask Ping
 | Note: | 4672 is the default port, but other clients may have different settings. Change the remote port to any when configuring a firewall
5) | Local Port: | any
 | Remote Port: | 4661
 | Protocol: | TCP
 | Direction: | outgoing
 | Purpose: | Connection to server
 | Note: | 4661 is the default port of a server. Many server use different ports. Configuring a firewall the remote port again changes to any.
6) | Local Port: | any
 | Remote Port: | 4665
 | Protocol: | UDP
 | Direction: | outgoing
 | Purpose: | Source asking on servers
 | Note: | Servers using the default port 4661 TCP (see #5) automatically set their port for source asking to 4665 UDP. If a server uses a different port in #5 the corresponding UDP port is set to [Connection Port + 4]. For firewalls the remote port here is any.
7) | Local Port: | 4711
 | Remote Port: | any
 | Protocol: | TCP
 | Direction: | incoming
 | Purpose: | Webserver
 | Note: | This is the default port for the web interface. When using a router this port has to be forwarded or no connection to the webserver will be possible.

23.07.2003 11:15


130

 Updating the Server List

In eMule, eDonkey2000 servers are used to provide an entry point into this network. A connection to a server is necessary to access the network's resources and to make your client known to the network.

Basically a server provides only an index for the files, the connected users share. Searching for downloads or for sources of a download is done over the servers.

A server list update in eMule is only need for a first contact to the network. As soon as eMule is connected to a server it offers intelligent features like Client to Client Source exchange to find sources or automated updates to the known servers.

There are several ways in eMule to update the server list:

Useful Settings in Preferences -> Connections
o Auto-update serverlist at start up
In the directory you unzipped/installed eMule to, you’ll find the file adresses.dat. Open it with an ASCII editor (e.g. notepad) and enter a valid URL to a server.met. Only one URL is supported.
Checking this option, eMule will update its server list from the URL provided in the adresses.dat at start up.

o Update serverlist when connecting to a server
eDonkey servers know of each other to a certain extent. With this options eMule will retrieve the list of known servers from the server it is connected to.

o Update serverlist when a client connects
This feature works upon the connection of another eMule client to your client. Both clients will compare their working servers and update their lists accordingly.

Note:
The later two will keep the server list updated permanently. Regularly updating the server list is not necessary.

Update Server List from URL

Enter a URL to a server.met in the box and press Update. The Log windows will inform you how many new servers were added.

Add Single Server

Enter IP and a server name to add a single server to your list. If a Log messages says Server not added! the server is already in the list.

Add Servers via IRC
The official eMule IRC channels feature a !serverlist command. This command sends you a message with server list URLs. Using eMule's IRC chat, links to a server.met can be added directly to the list by cklicking on them.

Add Server from Web Link
The eDonkey2000 network offers special html links, e.g. ed2k://|server|IP|port|/ to add a server directly to eMule.

01.05.2004 19:03


131

 Addresses to Server Lists

eMule uses the same servers as eDonkey2000 does, so the server lists are valid for eMule as well.

Web Sites to find Server lists:
 | TheDonkeyNetwork
 | Server List for eDonkey2000

Direct links to the well known ocbMaurice Server lists:
 |  | Default
 |  | All servers
 |  | Working Servers
 |  | Long time proven servers
Notes:
> | Use Google to find many good sites with server.mets.
> | Any of these links may die or go down. This is only a place to start.
> | Big thanks to the people providing these lists. Great work.

23.07.2003 11:44


132

 Dynamic DNS Resolution

Dynamic IP is a way to increase the pool of limited IP addressees (theoretically 2^32) in the World Wide Web. Many ISPs use this system, cutting the connection after a set period thus forcing a redial and a newly assigned IP.

This is bad for the server because the server looses its unique address, which was known in the network and all its users.

Many free web services offer a way to solve this by allowing static host names for dynamic IP addresses.

Enter [emDynIP: StaticHostName.host:Port] as welcome message in the dserver.
For a server with default settings, the port would be 4661.

This will instruct eMule to use the static host name instead of the dynamic IP when connecting.
It also offers the advantage of adding the host name to staticservers.dat so its address never gets lost.

Notes:
> | The length of the static host name must be smaller than 51 letters.
> | This only applies to people running a server for the network. If you are running the eMule client, it's of no use for you.
> | Big kudos to all people running a dserver. You're doing a great service for the community.

23.07.2003 11:45


133

 Searching for Files

Searching for files in eMule usually means that all servers in the server list are asked if they know another client you has a file with the matching search keyword. The servers themselves do not store any files, they just compile a list of the connected clients files.
The advanced search function in eMule allows precise searches for files in the network. The more accurate a search is done the better it is since searches put a considerable load onto the servers. Therefore eMule only finds max 200 individual hits for any given search term. If the connected server, could already give more than 200 results the More button becomes active and allows to query up to 1200 results from the local server.

Search
o Name
This filed takes the term to search for. Multiple keywords can be entered and eMule will displays only hits with all the keywords in the filename. For more accurate and flexible searches see the boolean search further down this chapter.
This textbox has an auto-completing feature which stores previous search entries. To clear this list press and hold CTRL or ALT then press DEL or use the Reset Button in Preferences -> Display. There this option can also be deactivated.

o Search with Unicode
This feature has been added to eMule in v.44a and will allow to search for files with non Latin letters, e.g. Japanese, Hebrew, Arabic etc. As Unicode clients are not so far spread at the moment and Unicode searches may not yield as many results as ANSI searches, this checkmark can be used to specifically search in Unicode. It is only active if a Unicode letter is entered.

o Type
Type can be used to filter the hits for specific group of extensions. The type of download and their associated extensions are given in the table below:
All | no filter
Archive | .ace, .arj, .gz, .hqx, .lha, .rar, .sea, .sit, .tar, .tgz, .uc2, .zip, .7z
Audio | .669, .aac, .aif, .aiff, .amf, .ams, .ape, .au, .dbm, .dmf, .dsm, .far, .flac, .it, .mdl, .med, .mid, .midi, .mod, .mol, .mp1, .mp2, .mp3, .mp4, .mpa, .mpc, .mpp, .mtm, .nst, .ogg, .okt, .psm, .ptm, .ra, .rmi, .s3m, .stm, .ult, .umx, .wav, .wma, .wow, .xm.
Images | .bmp, .dcx, .emf, .gif, .ico, .jpeg, .jpg, .pct, .pcx, .pic, .pict, .png, .psd, .psp, .tga, .tif, .tiff, .wmf, .xif
CD-Images | .bin, .bwa, .bwi, .bws, .bwt, .ccd, .cue, .dmg, .dmz, .img, .iso, .mdf, .mds, .nrg, .sub, .toast
Programs | .bat, .cmd, .com, .exe, .ace, .arj, .gz, .hqx, .lha, .rar, .sea, .sit, .tar, .tgz, .uc2, .zip, .bin, .bwa, .bwi, .bws, .bwt, .ccd, .cue, .dmg, .dmz, .img, .iso, .mdf, .mds, .nrg, .sub, .toast, .7z
Video | asf, .avi, .divx, .m1v, .m2v, .mov, .mp1v, .mp2v, .mpe, .mpeg, .mpg, .mps, .mpv, .mpv1, .mpv2, .ogm, .qt, .ram, .rm, .rv, .vivo, .vob, .wmv

o Method
Method is the way eMule searches. Also web based search engines for the eMule network are available. The results of the web searches will open in the browser.
> | Server Only the server, the client is currently connected to will be searched.
> | Global (Server) All servers from the server list are queried. Each server is asked individually. The green bar at the bottom shows the progress of the search.
> | Kademlia Searches all the Kademlia network for the given keywords. The eD2k network, i.e. servers are not search with this method. It may take some time until the search results arrive. Should even a popular search expression yield no results then the system's UDP Port is probably blocked by a firewall or router.
> | Jigle (Web) Web based search engine. The Match Keyword checkbox forces Jigle to return only results which have the exact search keyword as a single phrase in the filename.
> | Jigle This method offers direct access to the Jigle Database from within eMule.
> | Filedonkey Web based search engine

Filter
o min size / max size
Min and max size is used to narrow the search according to file size. Only hits are displayed which are either over a entered min size or below the given max size. If no additional unit abbreviation is entered file size is assumed in Mega bytes.
Unit | Valid abbreviations
Bytes | b | byte | bytes
KiloBytes | k | kb | kbyte | kbytes
MegaBytes | m | mb | mbyte | mbytes
GigaBytes | g | gb | gbyte | gbytes

Examples:
Min size = 200
without further unit specified, this will only return files with a minimum size of 200 mega bytes
Max size = 1gb
file size must not exceed 1 giga byte

o Availability
Denotes the minimal number of sources for a single file one individual server must have for the search term to be counted as hit.

Note:
This filter does not respect the global availability but a per server availability. Setting this value too high may result in no hits as the servers might not have indexed files with that many sources.

o Extension
Only files with the provided extension will be found. The extension has to be entered without the trailing . e.g. the extension avi will only find this file type.

Boolean Search
This function is used to create complex search queries using the boolean operators NOT, AND, OR. These operators always have to be entered in capital letters otherwise they are counted as a normal search Keyword.
> | NOT This operator is actually called NAND which means "and not". The keyword following a NOT will be excluded, i.e. no hit may contain this keyword. Highest precedence. String: Keyword1 NOT Keyword2
> | AND AND is the default operator if no operator is specified. AND-linked searches must contain all entered keywords in the resulting hits. Medium operator precedence. String: Keyword1 AND Keyword2 (equals: Keyword1 Keyword2)
> | OR OR means that any of the entered keywords result in a hit. OR has the lowest precedence String: Keyword1 OR Keyword2
Notes:
> | Kademlia searches must always start with a keyword having 3 or more letters. After the first keyword there must not be any boolean operator apart from AND.
> | Except for the web based search engine filedonkey the boolean search may be combined with any method or filter.
> | The operators are evaluated according to their mathematical precedence. NOT -> AND -> OR. This precedence can be change by setting ( ) around the expression which has to be evaluated first.
> | To mask the operators or ( ) quotation marks " " can be used. Operators or ( ) enclosed in " " will not be interpreted by their boolean meaning but be used as normal search keywords.
> | OR and NOT linked searches are not as restrictive as AND searches. AND requires the whole keyword to match whereas OR and NOT also allow partial matches in another word.
> | OR and NOT also take into account embedded meta data like mp3 tags or comment / author information of files.
Examples:
> | Search | Keyword1 Keyword2 OR Keyword3 Keyword4
 | Boolean interpretation | (Keyword1 AND Keyword2) OR (Keyword3 AND Keyword4)
 | Explanation | Finds files that must contain either keyword 1 + 2 or keyword 3 + 4 in the filename.
> | Search | Keyword1 Keyword2 OR Keyword3 Keyword4 NOT Keyword5
 | Boolean interpretation | (Keyword1 AND Keyword2) OR ((Keyword3 AND Keyword4) NAND Keyword5)
 | Explanation | All files with keyword 1 + 2 or keyword 3 + 4 but any files matching 3 + 4 must not contain keyword 5
> | Search | Keyword1 Keyword2 NOT Keyword5 OR Keyword3 Keyword4 NOT Keyword5
 | Boolean interpretation | ((Keyword1 AND Keyword2) NAND Keyword5) OR ((Keyword3 AND Keyword4) NAND Keyword5)
 | Explanation | Similar to the example above with the only difference that keyword 5 must neither appear with 1 + 2 nor with 3 + 4.
> | Search | (Keyword1 Keyword2 OR Keyword3 Keyword4) NOT Keyword5
 | Boolean interpretation | ((Keyword1 AND Keyword2) OR (Keyword3 Keyword4)) NAND Keyword5
 | Explanation | Same search as the one above but more elegant through the use of ( ) to apply the NOT keyword5 to the entire OR expression
> | Search | (Keyword1 "OR" Keyword2) NOT Keyword3
 | Boolean interpretation | (Keyword1 AND or AND Keyword2) NAND Keyword3
 | Explanation | By using " " to include the term, the OR operator is no longer counted as such but as a regular expression. This search translates to hits which must contain keyword1 and keyword2 and also the word "or" but must not contain keyword3.

Interpreting the Results
o Availability (Sources)
The availability is the number of sources found on the servers for a download. This is not the total number of sources in the entire net but serves as an indication how well spread the file is. If there are different matching hits for a search the file with highest availability should be chosen. Also see Color coding of Search Results.
A value in ( ) behind the availability are sources which can be added directly to the download without eMule having to search for them again.

o Color coding of Search Results

> | Black, dark blue, light blue Indicates the number of sources found for a specific file. Black = 1 - 3 sources, dark blue = 4 - 9 sources, light blue = 10+ sources
> | red Files already in the download list are shown in red
> | Green Hits shown in green are already downloaded and completed.

o Searching within the results
Pressing CTRL + f shows a search dialog which can search for keywords (File name), ID, size, type and availability. The function key F3 jumps to the next found item with the same search keyword while SHIFT + F3 jumps to the previously found.

o Multiple names found for one file
Files are identified by their hash values and not filenames. A search may yield many different file names for the same file. This is shown by an Explorer like + before the search result. If a result has vastly different filenames, this may be a fake.

Applies to version: .44a +
Last update on: 2004-09-11, Monk

12.09.2004 7:55


134

 Credit System
The credit system is used to reward users contributing to the network, i.e. uploading to other clients.
The strict queue system in eMule is based on the waiting time a user has spent in the queue. The credit system provides a major modifier to this waiting time by taking the upload and download between the two clients into consideration. The more a user uploads to a client the faster he advances in this client's queue.
The modifiers are calculated from the amount of transferred data between the two clients. The values used can be seen in the client's details dialog. To view this information, right click on any user and choose View Details.

There are two different credit modifier calculated:
 | Ratio1 = Uploaded Total x 2 / Downloaded Total
 | Ratio2 = SQRT(Uploaded Total + 2)
Both ratios are compared and the lower value is used as modifier.
Some boundary conditions also exist:
 | > | Uploaded Total < 1MB => Modifier = 1
 | > | Downloaded Total = 0 => Modifier = 10
 | > | The modifier may not be lower than 1 or higher than 10

Notes:
> | All Clients uploading to you are rewarded by the credit system. It does not matter if the client supports the credit system or not.
> | Not supporting clients will grant you no credits when you upload to them.
> | Credits are not global. They are exchanged between two specific clients
> | Credits are stored in the clients.met file. The unique user hash is used to identify the client.
> | Your own credits are saved by the client who owes you the credit. This prevents faking the credits.
> | Your own credits cannot be displayed

Last update on: 2003-04-13 by Monk
01.03.2004 15:54


135

 Secure User Identification

Clients in the network are identified by a unique value called user hash. This user hash is stored in the preferences.dat file and is used to grant earned credits with other users.
eMule can use an asymmetric encryption to avoid exploiting or manipulating other users hash values. The method uses a private and a public key to secure the user hash and to ensure a proper identification on other clients.

Secure User Identification can be turned on in Preferences -> Security. It is recommended to use it.

How secure user identification works:

Client A wants to make sure that his credits are safe and only used by him. He creates a private 384 bit RSA key and stores it in the cryptkey.dat file.
This private key is created when the encryption is used for the first time. Losing this key means Client A loses all his credits since he is no longer able to prove that he is the valid owner of them.

When two encryption supporting clients exchange data for the first time they both send a public key together with a random value to their partner. Each stores the other ones key in its clients.met file. Only the key is saved, the random value is generated new each following connection.

Does client A wants to identify himself on client B at a later time he creates a digital signature and sends it to B. This signature is from his private key, the public key of B and a random value. It is valid until client A changes his IP or client B closes eMule.

After receiving A's signature client B checks if it is created from his public key B and the correct random value. If it also fits client A's public key, then client A is correctly identified.

Notes:
> | If the cryptkey.dat file is lost or deleted, the preferences.dat file has to be also deleted or no new credits can be collected on already known clients.
> | When switching to secure user identification all old, "unsecured" credits will be lost. For security reasons, there is now way to transfer these credits to the secure system.

Applies to version: .29b +
Last update on: 2003-06-20 by Monk

18.03.2004 13:44


136

 Aggressive Client Ban

If another clients wants to download a file from you, he will request this file and reask every 10-20 min to make sure that you are still a valid source. However it is possible to adjust clients so they ask more frequently. This will give the modified client a higher chance to to get an upload slot on eDonkey clients.
eMule does not care about the reask frequency and the chances to get an uploadslot won't increase. Such behavior wastes valuable ressources (connections and bandwidth) and will be blocked.
The new client system will blacklist clients which reask too often (more than once for a file within 10 min), and they are not allowed to download from you. The blacklist is cleared when you restart emule.

Examples how to get blacklisted (you won't be able to download from emule clients):

> Setting the reask-parameter of your client lower then 10 min.
> Setting your downloads to pause and resume to increase your downloadspeed regulary - which will result in a new filerequest everytime (eDonkey clients only)
> Restarting your client every 2 min (which will also result in a new request).

To make it clear: eMule does not care which client (eMule/eDonkey/mldonkey) asks. Each client that reasks too often will be banned.

24.07.2003 8:12


137

 Source Exchange
eMule is able to acquire sources for downloads from other eMule clients.

For well shared files every 10 minutes a random client in the source list of a particular download is asked for its sources.
If the file is rare, i.e. less than 40 sources, every client in the list is asked for its sources in this interval.

Only sources for missing parts are acquired. This is done via TCP and the packets are compressed to save bandwidth.

Notes:
> | The protocol used is not compatible with mldonkey's source propagation protocol.
> | Client to Client Source Exchange is done over the Client Port 4662 using the TCP protocol
> | Low ID sources are not traded

Applies to version: 0.22a +
Last update on: 2003-05-04 by Monk
01.03.2004 15:59


138

 Preview Multimedia Files
Basic Preview
Just right click on the file and choose Preview. eMule then creates a temporary file in eMule's Temp folder and opens it in the default media player.

Supported formats at the moment:

- *.avi
- *.mpg
- *.mpeg
- *.divx
- *.xvid
- *.zip
- *.rar
- *.ace
- any multimedia format when VLC is used

Notes:
> | Preview only works when the first and last parts have already been downloaded and enough space for the preview file is available on your Temp disk.
> | You still need the right codec for the file to view. Missing codec will produce an error message or the file is played with sound but no picture. If you are not sure which codec was used try a Codec Pack

Preview multimedia files with VLC

VLC is a player which allows playing back almost any multimedia file. VLC creates a multimedia stream from the file and thus is able to play back even broken / incomplete files or streamed content across a network. It is well suited for previewing files in eMule.

Using VLC:
> | Download VideoLAN Client - VLC
> | Set the complete path to the vlc.exe (typical: C:\Program Files\VideoLAN\VLC\vlc.exe) in Preferences -> Files -> Video Player
> | Disable Create backup for preview in the same dialog
> | In Preferences -> Preferences.ini set PreviewSmallBlocks to 1. Warning: This setting might crash any other player than VLC

VLC and eMule Part File Access Module

The eMule Part File Access Module is a plugin for VLC specifically developed to play back incomplete or broken files. Using this plugin such content may be played back without stuttering and even seeking, i.e. jumping to any given position in the video, is possible. Reading the information which parts are available for an incomplete download from eMule's .part.met files it also saves the time consuming scanning for usable parts.

o Downloading and installing the plugin

> | Download the plugin on the eMule Project Homepage in the Downloads section.
> | Unpack the zip file and copy libaccess_partfile_plugin.dll to VLC's plugin directory (typical: C:\Program Files\VideoLAN\VLC\plugins)
> | Configure eMule for the use with VLC as described above
> | Important: The plugin is only compatible to the given VLC version!
 |  | Part File Access Modul v1.1 <=> VLC v0.6.2
 |  | Part File Access Modul v1.2 <=> VLC v0.7.0

o Configuring the plugin

After starting VLC the configuration dialog of the plugin can be found in Settings -> Preferences -> Plugins -> access -> access_partfile

Enable plugin for MPEG / AVI / non MPEG or AVI part files
These three "enable" options decide which files should be processed by the plugin. "non MPEG or AVI part files" are files like .ogg, .ogm, .mp3, .mkv etc.
If possible VLC will try to use its default access module instead of the plugin if any of the options is disabled.

Provide a seekable stream for MPEG / AVI / non MPEG or AVI part files
Normally streams from incomplete or broke files are not seekable, i.e. the positioning slider to skip around in the video or the fast forward function cannot be used. Enabling the options for a seekable stream will allow this functionality for eMule's incomplete downloads.
These options only work if the plugin is enabled for the specific file type. In some cases, especially with AVI or other non MPEG content, the seekable streams may not work correctly.

Enable plugin for all type of files (eMule part files and regular files)
This plugin is designed for using it with eMule's .part files. The default access module in VLC has a bug which may freeze the entire system when trying to open broken or incomplete content. This plugin offers a workaround for this bug with the option to open all VLC supported content with this plugin instead of the default access module. Activating this option means that all supported content is processed by the plugin regardless if opened from within eMule, the explorer or command line.
The eMule Part File Access Module is a full replacement for the default access module in VLC.

Different Preview Applications
Not all player applications perform equally well on all kinds of files. One of the most flexible is for sure the Video LAN Client but players like Media Player Classic or Zoom Player also work very well with incomplete files.
To configure eMule for offering a choice of different players a file named PreviewApps.dat has to be created in eMule's config folder. This is a normal text file created e.g. with Windows Notepad. The applications used for preview have to be entered in the following format

<Menu Label> = <Application-Path> <Application-Commandline-Arguments>
<Menu Label> | Is the name, the application appears in eMule preview menu
<Application-Path> | This has to be replaced with the full path to the players executable file. Paths with blanks must be enclosed in ""
<Application-Commandline-Arguments> | This can be optional command line arguments for the application
Examples:
VideoLAN Client 0.6.2=C:\Programme\VideoLAN-0.6.2\VLC\vlc.exe
VideoLAN Client 0.7.1=C:\Programme\VideoLAN\VLC\vlc.exe --config "%USERPROFILE%\Applicationdata\vlc\vlcrc-0.7.1"
Media Player Classic="C:\Programme\Media Player Classic\mplayerc.exe"
Notes:
o | Running eMule as unprivileged user may result in some applications not working correctly as all started programs only have the restricted user permissions.
o | Command line arguments can even be system variables like %USERPROFILE%. In this case the variable would be replaced with the system path for "Documents and Settings" with the appropriate user folder. This is useful for configuring some applications to run correctly as unprivileged users.

Screenshot Preview of Video Files
If another client allows to view the list of his shared files (Preferences -> Files -> See my share) it is possible to get a preview of his shared video files.
Right clicking on a shared video -> Preview will request a set of 5 screenshots of the initial 10 minutes of this file. The screenshots are displayed in a separate viewer as soon as received. It may take a while for them to arrive. This function only works between v.30b or higher clients.

Applies to version: .42b +
Last update on: 2004-05-01, Monk

02.05.2004 16:31


139

 Online Signature
If the feature Use Online Signature in the Preferences dialogue is checked eMule will write the file onlinesig.dat to its directory.

Format of onlinesig.dat:
[Online status] | [Connected Server] | [IP:port]
[Current Download] | [Current Upload] | [Users on queue]

In the future this might be extended to a remote logging but in the meantime there is a nice tool by Dra.:.god called Online Signature. It allows you to modify an image file with the data from onlinesig.dat and send it to webspace via FTP.

Applies to version: .22a +
Last update on: 14/12/02 by Monk
01.03.2004 16:02


140

 IRC Chat

The IRC chat module in eMule will connect you to:

irc.freshirc.com

If you are looking for help or just want to visit us join:

> #emule (English)
> #emule-german
> #emule-french
> #emule-spanish

See Preferences -> IRC for details on the IRC configuration.

Rules:

> Do not message ops (people with @ before their names)
> Do not ask or offer Warez or any other copyrighted material
> Do not spam the channels with scripts
> No advertising in the channels

Applies to version: 0.22b +
Last update on: 2004-02-27 by Monk

01.03.2004 16:04


141

 Friends

The eDonkey network is big, so finding someone again is hard. The Friends feature offers an easy and convenient way to keep track of people with the same interest or liking. Especially for groups releasing files this is a valuable addition.

Source Context Menu (right click on a source in the Tansfer lists)

o Show Details
Shows some information about transferred data, ratings and modifiers of this user.

o Add to Friends
An user added as Friend shows the Friend icon instead of the client icon and is listed in the Messages Tab.

o Send Message
Starts a private chat session with this user.

o View Files
Depending on the action set in Preferences -> Files the list of shared files can be requested from a Friend. Note that eMule’s default setting for View Files is to deny the request. If the request is successful this user’s files are displayed in Serach.

Friends Actions
The added Friends are listed in the Messages tab and allow various actions.

o Show Details
Same as above.

o Remove Friend
Removes the Friend from the list.

o Send Message
Same as above.

o View Files
Same as above.

o Establish Friend Slot
A reserved upload slot can be assigned to a Friend thus allowing him to make a direct connection without having to wait in the queue.
Only one reserved slot is allowed.

Friends Icons

This friend is currently transferring or connected.

Friend is in the list of currently known clients.

Status is offline or unknown.

Note:
The Friends status is not updated regularly to save bandwidth. To know the actual status an action has to be performed.

Applies to version: .23a +
Last update on: 2003-03-27 by Monk

01.03.2004 16:05


142

 IP Filters

Sometimes it happens that users send, intentionally or without knowing, corrupted data. This may prevent a file from completing properly or the file being totally corrupted.
eMule introduces a basic filtering of IP's. The IP-Ranges to filter are stored in a file named ipfilter.dat which is saved in eMule's install folder. This blacklist has the following format:

# Example of a "ipfilter.dat" file
#
# All entered IP ranges will be blocked in eMule for both Up- and Downloading
# Be extremely careful what you enter here. Wrong entries may totally block eMule from accessing the network
#
# Format:
# IP-Range , Access Level , Description
#
# Access Levels:
# <127 blocked
# >=127 permitted

064.094.089.000 - 064.094.089.255 , 000 , Gator.com

This entry will block the IPs from 064.094.089.000 to 064.094.089.255, i.e. eMule will not connect to any IP out of this range, neither for uploading nor downloading data.

Warning:
The example above will block any connection to the specified IP-range. This may reduce the number of sources for downloads.

At the moment only one access levels are implemented. A value below 127 (default in Preferences -> Security) means that any connection-attempt is denied.

Updating the IP Filter
In Preferences -> Security is the option Update from URL. Add a link to the filter file, e.g. http://bluetack.co.uk/config/antip2p.txt and press Load. IP Filter formats used in Methlabs, Bluetack or Lussnig's IP Filter lists are supported by this function. Links which point to a *.zip file may also be added as long as the contained list has a supported format.

IP Filter Tools
In the Tools area or in the Hotmenu (Alt+x) you can use the IP Filter Tools for appending additional lists, deleting entries and other manipulations. Also a Hits statistic is displayed which show how often a certain IP was filtered.

Notes:
• | Filtering will prevent up- and downloading to the banned clients
• | It is not possible to add single clients by mouse click to the list of banned clients nor will it ever be.
• | Filtering is done on TCP level so no connection to banned clients is ever established.

Last update on: 2004-08-18 by Monk

18.07.2004 14:12


143

 Categories

All files in Transfer's Download list can be added to self defined categories. The first category is always all which shows either all downloads or downloads filtered by the View Filter. To access the options for the categories right click on any existing category.

Select View Filter
This option is only available in the first category and let's you filter it for certain file types or file statuses.

All | no filter, all files are shown
Uncatalogued | Only downloads which are not in any self defined category are shown
Incomplete, Completed, Waiting, Downloading, Erroneous, Paused, Stopped | Filters the list according to the downloads status as displayed in the Status column
Video | Video files with following extensions .mpg, .mpeg, .avi, .divx, .rm, .ram, .wmf, .asf, .vivo, .mov, .ogm, .vob
Audio | Audio files: .wav, .mp3, .ogg, .mp4, .aac, .flac, .ape, .au, .wma, .mpc, .mp2
Archive | Archive files: .rar, .zip, .ace, .gz
CD-Images | .cue/.bin (CDRWin), .mds/.mdf (Alcohol120%), .ccd/.../files/help/1033/.sub (CloneCD), .bwa/.bwt/.bwi/.bws (BlindWrite), .nrg (Nero)

Add Category
Creates a new Category. The settings to choose for this category are optional and the default Incoming Files Folder is used unless specified otherwise.

o Title
Name of the Category as it will be displayed

o Comment
Description or comment.

o Incoming Files
A separate Incoming Files directory can be used for each category. Completed files are move to this folder. eMule uses the default folder when leaving it empty.

o Change priority for new
Files added to this category are automatically set to the specified priority.

o Automatic Category Assignment
When starting new downloads, they can be assigned automatically to this category, if the filename matches a given pattern. | is used to separate different keywords and * can be used as a wildcard for an arbitrary string.
Example: *.avi|a*.*
This would assigne new files with the extension 'avi', and filenames starting with an 'a' to this category.

o Color
Defines the color used for the files of this category. This setting also affects the category all to show all files and their corresponding category on one glance.

Edit Category
All settings of Add Category can be changed at any time.

Remove Category
Deletes the selected category. The files in the category will not be affected.

Priority, Cancel, Stop, Pause, Resume
These commands apply to all files of the category. Be careful with the Cancel command.

Download in alphabetical order
See the Chapter Source Management for more details on categories priority and this option.

Resume next paused
Upon completing of another download a paused download of the chosen category will be resumes.

Adding files to Categories
Files can be added to categories by a download's context menu (right mouse button) -> Assign to Category or by drag and drop. Select a download, hold down the left mouse button and drag it to the desired category. Multiple files can be selected with the CTRL-key or the SHIFT-Key.
In the Search windows files can be added directly to categories by choosing it with the buttons on the bottom of the search dialog before downloading a search result.

Applies to version: .43a +
Last update on: 2004-07-18 , Monk

18.07.2004 13:30


144

 Webinterface
eMule features a Webinterface which allows remote access and administration of its functions and settings. The Webinterface can be opened within any browser as long as the current IP address of the machine hosting eMule is known.

To connect to the Webinterface the IP address and the corresponding server port have to be entered as address in a browser. The address has to look like a normal web URL, i.e. http://xxx.xxx.xxx.xxx:port. The Xs represent the current IP address and port is 4711 when using the Webinterfaces default settings. The server's port has to be forwarded if using a router or logon will not be possible. Refer to the Ports topic in this FAQ for more information
To test the server on the same machine eMule is running on enter the localhost http://127.0.0.1:4711 as address.

DynDNS Hosts
Many ISPs providing dial up access to the internet force a redial every 24h to assign a new IP address. In order to log into the Webinterface its current IP address has to be known.
Many free services provide a convenient solution to always know the current IP address - DynDNS Hosts. These services allow to assign a static host address like http://myAddress.myHost.com to machines on dynamic IP. A small utility, called Dynamic DNS Client Program, which has to run on the computer eMule is running on will update the IP address to the static host whenever the IP changes. Now the Webinterface can be simply accessed over the static host http://myAddress.myHost.com:4711.

If the correct address is entered the logon screen is displayed. To enter the Webinterface provide the password set in the Webinterface's preferences.

Important:
It is strongly recommended to set a proper password in the preferences. If no administrator password is set, anyone can access your eMule and may set preferences, delete or add files etc.

Access to nearly all functions of eMule is provided in this web interface. All changes will directly affect eMule on the server PC.

Applies to version: .27b +
Last update on: 2003-03-21 , Monk
01.03.2004 16:08


339

 Command Line Switches

Some of the basic functions in eMule may be controlled by command line switches. This allows execution in batch scripts or remote accessing eMule in a Telnet session.

Syntax:
emule.exe status

• | status
Writes some information on current transfers to the file status.log
• | connect
Connects to a server
• | disconnect
Disconnects from a server
• | limits=up,down
Sets the limits for up- and download speed. Same setting as in Preferences -> Connection -> Limits
• | resume
Resumes any paused or stopped file in the downloads list
• | restore
Restores a minimized eMule task
• | ignoreinstances
Allows the execution of multiple eMule instances. Note: For two eMules running on the same machine they must be installed to different folders, must have different temp folders and also the ports used by each eMule have to be unique. It is not recommended to run two eMules concurrently apart from testing purposes.
• | exit
Quits eMule
• | assertfile
Debug option. Wrtites possible assert information to a file instead of breaking execution.

01.05.2004 19:11


231

 MuleMRTG
MuleMRTG

The Windows NT series (NT, 2k, XP, 2003) is able to log and display performance information with the built in perfmon console. eMule (v.42.1+) is also able to log some performance data in the same format as perfmon does.

MRTG - Multi Router Traffic Grapher is a tool which displays this information as graphs in HTML documents. In the first place this tool is used to monitor in- and outgoing traffic of servers or routers but works equally well for long time monitoring of eMule. See this example.

The following procedure describes how to set up MRTG as a NT service using the installer provided on the Download page.
Works only on Windows NT, 2k, XP, 2003 not on Win9x/ME

• | Download and install Active Perl with default settings
• | srvany.exe and intsrv.exe are needed for MRTG to run as a service. Download Windows Server 2003 Resource Kit Tools (the MS installer works only for XP and 2003 but not for 2k (the contained srvany does work on 2k) or Google for a download of it. Copy the two files to any folder.
• | Download and run the MuleMRTG installer. You have to specify the path to the Active Perl installation (e.g. C:\Perl) and the path to srvany.exe. The other paths should be already filled with the correct paths. All used paths must not contains any blanks or trailling \

Every 5 minutes MRTG reads a sample from eMule's performance log and creates a HTML output to view. The HTML files are stored in the HTML Output directory and may be opened with any browser. Just doubleclick on the index.html file.

MRTG is used for long time statistiks. It takes about 10 to 15 minutes for the first dayly graph to display.

Applies to: v.42.a+
Last Update: 2004-02-27, Monk
28.02.2004 17:39


422

 eD2k Links

eD2k links are a special link format which allow adding a download directly to eMule. These links allow webmasters to offer eMule downloads directly from their web pages and make it very easy to exchange downloads in the network. A great place to look for such links is the eMule Content DB

Linkformat
eMule supports very sophisticated means of generating and using such links.

• | Basic eD2k Links
 | ed2k://|file|<file name>|<file size>|<file hash>|/ The most basic form of an eD2k link containing only the necessary file descriptions like name, size and hash
• | eD2k Links with hash set
 | ed2k://|file|<file name>|<file size>|<file hash>|p=<hash set>|/ The complete hash set in the files ensure that this is always correct and helps spreading new and rare files.
• | eD2k links with source
 | ed2k://|file|<file name>|<file size>|<file hash >|/|sources,<IP:port>|/ Adds one or multiple already known eMule sources in the format <IP:port> to the link, providing instant sources for the download.
• | eD2k link with host
 | ed2k://|file|<file name>|<file size>|<file hash >|/|sources,<host name:port>|/ Same as the link with sources but instead of using the IP it uses a host name. Offers more flexibility especially with changing IPs. A host name must be set in Preferences -> Extended Settings -> Hostname for own eD2k links
• | eD2k link in HTML
 | <a href="ed2k://|file|<file name>|<file size>|<file hash >|/">displayed name on the web page</a> Easy way to create a link already pepared for displaying it on a web page
• | eD2k link with HTTP sources
 | ed2k://|file|<file name>|<file size>|<file hash>|s=http://anyweb.net/filename|/ eMule is also capable of downloading directly from web sources. A very useful and convenient format for web masters. See the Link Creator in the next paragraph for more information.
• | eD2k link with Root Hash
 | ed2k://|file|<file name>|<file size>|<file hash>|h=<Root Hash>|/ The Root Hash links allows advanced error correction and check methods by supplying a trusted value for AICH. Read this for mor information on AICH and Root Hash.

Creating links in eMule
In eMule it is very easy to generate each eD2k link except for the HTTP links.
Select any download in your list and press the right mouse button:

The Shared Files main window offers even more possibilities for completed files:

The Link Creator
Web masters releasing popular software often face the problem of congested mirrors and immense traffic upon a new release. Offering web download sources and eD2k in the same link can greatly help in this situation. It offers a convenient way for the users to add the download to eMule as the download manager, spreading the file in the network and providing great download speeds through the HTTP servers.
The Link Creator is an easy to use tool to quickly generate such links.

Just enter the file to calculate the hash value for and generate the link. Optionally HTTP web sources may be added. Use the Remove button to remove a selected HTTP source or the Clear button to remove them all.
It is recommened to add the hash set also as this improves the reliability of the download. Pressing the Start button generates the link.

12.09.2004 8:09


427

 Source Management

Source finding in the network is of uttermost importance. In fact, servers, Kademlia and eMule itself are geared towards a most efficient source acquiring. For best eMule performance some concepts are necessary to understand. The source list of each download is shown by double clicking on it. For the advanced source information and handling the setting Extended Settings -> Show more controls has to be activated.

• | Finding sources for a download
 | eMule uses different means to find sources for downloads. Expanding a download by double clicking on it shows how the sources have been found in the Size column.
 | - | eD2k Server Source was found by querying either the connected server right after the download was added or by asking any server in the servers list in regular intervals.
 | - | Kademlia Kademlia offers a very fast way to find sources across a large number of distributed users without the need for central servers. For more Information see the Network Guide.
 | - | Source Exchange After a source has been added for a particular download, eMule asks this sources if it knows further sources for parts still missing in the own download. If yes, the connected client sends a list containing the sources.
 | - | Passive Passive sources are other clients who connect. eMule asks them if they could be source for one of its own downloads and if they are not known before they get added as source for the appropriate download.
• | Total number of sources Basically the more sources found for a download the faster the download will be but there is a limit. Too many sources in total will slow down eMule as the connection will be congested by managing the sources, thus slowing down the actual download. The total number of found sources for all downloads is display in the Statistic main windows -> Transfers -> Download -> Found Sources. It should not exceed 3000 by much on most lines.
• | Queue and source status Once another client is added as a source it gets queried for the current source status . Possible source status are:
 | - | On Queue and QR: xx This is the Queue Rating. It denotes the waiting place in the queue of this client. When the beginning of the queue is reached, i.e. QR:1 this source will start uploading data. Credits modify the progression speed in the queue.
 | - | Queue Full The maximum queue limit of this source is already reached as too many other clients are already waiting in it.
 | - | Too many connections Currently eMule is too busy querying other sources so this source gets delayed until a connection is free to query this source. This status usually disappears very quickly. If it does not eMule has to cope with way too many sources. See the point Total number of sources in the paragraph above.
 | - | No needed part (acronym: NNP) The source does not offer any parts the own download is missing. The available parts of the source are also shown in the colored bar.
 | - | Asked for another file (acronym: A4AF) One particular source can be used only for one download. If this source would also provide parts for another download, eMule decides which download receives it. The other download will then list this source as Asked for another file. The next paragraph describes eMule's sophisticated handling of these sources.

Advanced A4AF Handling

This picture shows some downloads with their found sources (Advanced Controls turned on). The fourth file for example has 27 sources in total of which 26 are useful and 49 are A4AF.
If downloads belong to a series of files or are split into multiple parts, eMule will show a source distribution alike the picture above for Filename1_Part_X. It is most likely that the sources found for one of the files could also provide parts of the other as they belong together. eMule occupies only one queue place on the sources hence the high count of AF4A for these files.
There are two controls offered in this context menu to deal with these A4AF sources on a per file basis. The Priority and the Automatically Swap All Sources To This File control.

Also the Category context menu offers means of dealing with A4AF sources. Here they are the categories Priority and Download in alphabetical order.

eMule's advanced A4AF handling decides which file gets a source by following order:
• | Automatically Swap All Sources To This File (highest importance) Only one file may have this checks and always gets the A4AF sources.
• | Category Priority Files in a category with high priority are preferred over files that are uncategorized or in ones of lower priority
• | File Priority In a given category the file priority decides which file will receive the sources
• | Download in alphabetical order (lowest importance) Assigns the sources according to the file name of the download. In the example above with Filename1_Part_X this would mean the Filename1_Part_1 gets all the A4AF sources, when it is finished all sources are swapped to Part_2 etc. For downloads which fit into this pattern it is recommended to create a category for them. Make sure the files are named in alphabetical order and check this option. To rename a download hit F2 or click the middle mouse button on it or chose Show file details from the context menu.
Notes:
• | Setting a category to Download in alphabetical order will switch all files to Normal priority. Files later added to this category will retain their set priority. For the files to download alphabetically, make sure to set them to the same priority (not Auto).
• | A4AF handling checks if a source may be swapped to a lower priority file just for allowing client to client source exchange. This ensures that even low priority downloads find all possible sources fast.
• | Source swapping must obey the minimum reask time in the network. It may take up to 30 minutes before sources are swapped.
• | A source with a QR lower 50 will never get swapped from the highest priority download to ensure it starts downloading from it.

Applies to version: .43a +
Last update on: 2004-07-18 , Monk

18.07.2004 13:40


589

 Corruption Handling

eMule uses various means to make sure that files in the network are shared and downloaded without errors. Should an error occur, called corruption, eMule has advanced functions to correct this corruption with a minimum of additional data to redownload.

File Hash and ICH - Intelligent Corruption Handling

File Hash, Part Hashes & Hashset
For every file shared in the network an unique identification value is created using the mathematical crypto algorithm MD4. This value is called file hash and is contained in every standard eD2k link, e.g.

ed2k://|file|name|12043984|6744FC42EDA527B27F0B2F2538728B3E|/

where 6744FC42EDA527B27F0B2F2538728B3E is the file hash making this file uniquely identified all over the network.
This File Hash is calculated by dividing the entire file into parts of 9.28 MB. For each of the parts a Part Hash is calculated using the same MD4 algorithm. These Part Hashes, called Hashset, are then used to calculate the final File Hash. For example a 600 MB file would be divided into 65 parts each with its own Part Hash which are then used to create the final File Hash.
To make sure that eMule always receives the correct Hashset a special link can be created containing this, e.g.

ed2k://|file|name|12043984|6744FC42EDA527B27F0B2F2538728B3E|p=264E6F6B587985D87EB0157A2A7BAF40:17B9A4D1DCE0E4C2B672DF257145E98A|/

where the p= value denotes the Hashset. Each Part Hash is divided by a ":". This file has a size of 12043984 Bytes (=11.49 MB) which means it has one full 9.28 part and the rest left to 11.49 MB resulting in two Part Hashes.

ICH Intelligent Corruption Handling
Whenever eMule finishes such a part it will be checked if the downloaded data matches the Part Hash value for this finished part. If yes, this part is offered for upload to help spreading it.
If no, a corruption has occurred and the part has to be downloaded again. To avoid downloading the full 9.28 MB, ICH redownloads 180 KB from the beginning of the part and then check the whole part again to see if the Part Hash is now correct. If not, the next 180 KB are downloaded, check again etc. until the part hash is correct again. In the best case eMule has to download only 180 KB again if the corruption is right at the beginning of the part. In the worst case the entire part has to be downloaded again if the corruption is somewhere near the end of the part. On average ICH saves 50% of redownloading in case of part corruptions.

AICH - Advanced Intelligent Corruption Handling
The standard ICH is pretty effective although it has its limitations as only the whole 9.28 MB can be verified and no finer blocks. If more than one position is corrupted or if malicious clients spread corrupted data over and over again or even fake an entire Part Hash, ICH is no long effective.
Here AICH will care for complete data integrity with a minimum cost of redownloading or overhead by creating much finer hashes.

Root Hash, Block Hashes & AICH Hashset

This time our starting point are the 9.28 MB parts in a file. Each part is divided into 180 KB blocks, resulting in 53 blocks per part and for each block a hash value is calculated using the SHA1 hash algorithm. These values are called Block Hashes and form the lowest level of a complete AICH Hashset.
The image above shows how such a full hash tree is build upon the blocks of a full 4 parts file. Each part contains 53 blocks resulting in 212 Block Hashes which builds up a hash tree of further 7 Levels until the Root Hash is reached. The entire tree is called AICH Hashset.
The green and yellow dots show the mathematical dependencies of the smallest Block Hash to the Root Hash. This means if we have a trusted Root Hash the entire tree can be verified against it.
eMule can create links containing the Root Hash, e.g.

ed2k://|file|name|12043984|6744FC42EDA527B27F0B2F2538728B3E|h=A2NWOTYURUU3P3GCUB6KCNW3FTYYELQB|/

where h= is the Root Hash. For releases this value should be included as it significantly improves the corruption resistance of the file by providing a trusted Root Hash. Read Trusting the Root Hash

Recovering from a corruption
Whenever eMule detects a corruption in a part it requests a Recovery Packet from a random client with a complete AICH Hash Set. This Recovery Packet contains all 53 Block Hashes of the corrupted part and a number of Verifying Hashes of the entire hash tree. The image above shows a Recovery Packet for a 4 parts file. The number of Verifying Hashes is determined by the part count of the file (2^x >= 'part count', with x = Number of Verifying Hashes).
After receiving the Recovery Packet eMule checks the Verifying Hashes against its trusted Root Hash. If they match, eMule checks all 53 blocks of the corrupted part against the Block Hashes from the Recovery Packet. AICH then restores all blocks which match against their Block Hash to leave only the corrupted block(s) for redownload.
In the Log a successful recovery will look like:

09.09.2004 02:43:43: Downloaded part 6 is corrupt ([file])
09.09.2004 02:43:46: AICH successfully recovered 8.22 MB of 9.28 MB from part 6 for [file]

Trusting the Root Hash
The best thing is downloading from a link with a Root Hash. Assuming that the source of this link is trustworthy the Root Hash is trusted at once and saved to disk for this file.
If no Root Hash is provided in the link eMule has to trust the Root Hash, which the sources for the file send. It only trusts a Root Hash if at least 10 different sources send the same value and if at least 92% of all sources agree to this value. Because this Root Hash is not as trustworthy it is only valid for the current session and does not get saved nor can links with Root Hash be created.
Once eMule has build an entire AICH Hashset, i.e. the file is finished, it starts propagating the Root Hash to other clients.

Notes:
• | New releases or rare files will probably not have enough full sources to generate a trusted Root Hash. It is recommended to Release files with attached hash.
• | If there is no Root Hash or even a faked one eMule will be able to successfully download and finish the file under normal conditions. The AICH feature cannot be used in this case.
• | As AICH Hashsets can be very large they are not stored in memory but in the known2.met and are only read upon demand.
• | AICH will only be effective for eMule clients v.44a and above but retains backward compatibility to older clients.

Applies to: v.44a+
Update on: 2004-09-11 by Monk

12.09.2004 7:58


145

 Error Messages

A client caused an unhandled error while receiving or processing a packet. Disconnect
An error was detected which was caused by another client connected to you. The worst thing that can happen is that you’ll loose this one as a source.

Fatal error: unable to create socket on Port 4662
This error occurs if another application is using port 4662 to make connections. This is mostly the case when you use eMule at the same time as eDonkey without changing one of them to a different port.
It is not recommended to run both eMule and eDonkey or eMule and Overnet at the same time unless you have the (upload) bandwidth to do so.

ERROR: Your port 4662 is not reachable. You have a LOWID
eMule has detected that something is blocking your port 4662. This can be caused by firewalls or ill configured routers. Read the FAQ or search the forums on how to configure your firewall/router.

ERROR: Your port 4662 is not reachable. You have a LOWID http://www.edonkey2000.com/documentation/lowid.html ! Please correct your network config !
This error is similar to the one above. It will not pop up in the Log Window of the server but in the Serverinfo window. This message is generated by servers patched by Lugdunummaster. See here for details on Lugdunum patches.

Fatal Error while trying to connect. Internet connection might be down
The most obvious reason for this error is your connection is down, but it can also occur when your internet connection is very busy or you are using the firewall Zone Alarm which seems to handle many connections rather badly.

Error: Invalid part.met fileversion! (x.part.met => (null))
A serious error has occurred while eMule was writing data to a .part.met file. These are the files, in which eMule keeps track of temporary downloads.
The cause of this error is a crash of Windows or eMule. To recover the files you can try the following:

- Locate the file(s) in your Temp folder. If you cannot find them, you're out of luck
- Use a program like Known Metinator, DonkeyDoctor (Spanish, but program and help forum also in English) or eD2k RecoverMET to reconstruct the .met file.
- You can also try to run eDonkey with your current temp folder maybe it is able to correct the problem.
- See Troubleshooting -> Downloads for more details.

Always quit eMule before any operation and don't expect too much. This is a serious error and chances are good that you have to download the whole file again.

Status of a download shows "Errorious"
This is also a file operation error. It can occur when:

- eMule is unable to open a .part file.
Check your Temp folder in Preferences for correctness
Check if any files in Temp folder are write protected
Restart eMule

- Completing a download or moving it to Incoming
Check your Incoming folder in Preferences for correctness
Check the available space on the hard disk of the Incoming folder
Restart eMule

If nothing helps, quit eMule, delete the preferences.dat and known.met in the folder you installed eMule to, and then restart.

Client 'xxx' (IP:xxx.xxx.xxx.xxx) caused an error: corrupted or invalid hashset received. Disconnecting client!
Nothing you can do on your side. This was caused by another client who sent you a invalid hashset upon a source request.

Error: Unable to hash downloaded part - hashset incomplete (XXX). This should never happen
This error is a bug which can occur with small files. They will nevertheless be completed correctly. You can safely ignore this one.

Unexpected file error while writing XXX : An unknown error occurred while accessing C:\Program Files\eMule\temp\YYY.part
While eMule was trying to complete a file, it encountered a problem with the part file. Possible reasons are

- a moved Temp dir or .part file
- another program is accessing this file (e.g. Virus scanner, another p2p)

Check the reasons and restart eMule.

Invalid versions tag in server.met (0x3C)
Loading or updating the server.met caused a problem. Either a invalid server.met was updated from an URL or the own server.met file has been corrupted. Try another URL for updating the server list or delete the server.met file if the error persists.

An attempt was made to access an unnamed file past its end
This message pop up is caused by invalid packets from servers or other clients. This message does not affect eMule's operation and is properly handled in the versions .28a+

02.05.2004 16:34


146

 eD2k Links

eD2k web links are not added to eMule
If eD2k web links are not added to eMule when clicked on in the Internet Explorer, the special eD2k link format is not correctly associated. Check the eD2k Links button in Preferences -> General. If the button is inactive (greyed out) then some entries in Window's registry are messed up. Download this tool (by Resterampe) and remove the old association, then press the eD2k Link button again.

These registry entries are responsible for the web link format:
HKEY_CLASSES_ROOT\ed2k\shell\open\command
Name: (Standard)
Type: REG_SZ
Data: "Path to emule.exe(with quotes!)" %1

and

HKEY_LOCAL_MACHINE\SOFTWARE\Classes\ed2k\shell\open\command
same as above

Opera
Opera 7.2x and above
Run eMule. In Opera go to File -> Preferences -> Programs and paths -> Protocols and press the Add button. In the upcoming dialog enter ed2k in the Protocol field and the path to eMule automatically appears in the Open with default application. If it does not, the correct path to the eMule.exe will have to be provided in the Open with other application field.

Older Opera versions:
To allow weblinks to work from Opera, a configuration file in Opera's installation folder has to be edited. Quit Opera and open either one of the files in an editor, e.g. notepad.
Opera 6.x:
Add the line TrustedExternalURLProtocols=ed2k under [User Prefs] in the file Opera6.ini and safe it.
Opera 7.x:
For Opera 7.x add the same line in the file OperaDef6.ini.

Mozilla, Firefox
You will need a special plugin to associate different link formats like eD2k to the Mozialla or Firefox browser. Get mozex (alternate download link), open your browsers preferences and enter
path_to_eMule\emule.exe %r
in the eD2k edit box of the mozex plugin.

e.g.: C:\ProgramFiles\eMule\emule.exe %r

20.03.2004 15:55


147

 Webinterface
Webserver: Internet Explorer opens a download dialog instead of displaying the page
To prevent this the options Use HTTP 1.1 and Use HTTP 1.1 through proxy connections must be checked in IE's settings. Go to Extras -> Tools -> Internet Options -> Advanced : HTTP 1.1 settings
24.07.2003 8:58


148

 Downloads

After a bad crash download(s) may suddenly vanish from the list although their files are still in the temporary folder. This happens if a *.part.met gets corrupted.

General
Quit eMule before taking any recovery actions.
To make sure that everything is properly set up check Preferences -> Directories. The correct path to the temporary folder has to be entered.

Backups
eMule automatically creates backups (*.part.met.BAK) of all *.part.met files. If there are any differences in size or last modification (right mouse button click on the file -> Properties) delete the *.part.met file and rename the corresponding backup.

Recovery Tools
The Tools chapter holds some links to recovery tools. Backup the *.met and *.part files before attempting to recover them. Changes cannot be undone.

Manual Moving
In some rare cases a *.part.met file is so badly damages that it will prevent other files from loading. By adding the files one by one the damaged download can be identified and removed/recovered

1. Move all files from the temporary folder to a backup folder
2. Move one *.part and corresponding *.part.met back to the temporary folder
3. Start eMule and check if the download was correctly added to the list
4. Close eMule
5. Repeat steps 2. - 4. until the corrupt download(s) have been found
6. Either delete or try to recover the corrupt downloads with a recovery tool

01.03.2004 16:36


149

 Strange Behaviour
"Strange Behaviour"
If problems with updating the serverlist or lost settings arise some configuration files may be corrupted. This especially happens after crashes or after upgrading from modified versions of eMule. Deleting all *.met, *.ini and *.dat files in eMule's installation folder (do not delete your temp downloads!) may help with this problems. Quit eMule before deleting these files. After restart set the proper options in eMule's Preferences and restart again.
01.08.2004 13:59


150

 Server Connection
Disconnecting from server shortly after connecting
Many server limit the amount of shared files. If the set amount is reach the client automatically gets disconnected. eMule shows the number of shared files in its statistics page. Usually less than 500 shares will cause no troubles and makes sure that all files are accepted.
From eMule v.28 on the number of accepted files are shown in the server list. The Soft Limit value is the number of shares a server publishes, all excess files are ignored. When the Hard Limit is reach the server disconnects the client.
To prevent the disconnects eMule v.29 + only publishes the number of files allowed by the server's soft limit.
24.07.2003 9:05


229

 Blacklisted

The new Lugdunum patched servers p75+ have a credit system to judge the clients behaviour. Each action like connecting, searching, asking for sources etc. costs credit points.If they are all used up, the server disconnects and sends a warning that this client is blacklisted.
This especially is a problem when downloading more than ~30 files as the source asking for all this downloads will cost that many credits, banning the client. eMule v.30a+ takes care of this problem.
Additional information on this topic on SilentBob's web site.

Last update: Monk

02.01.2004 21:01


98

 Beginner's Guide
1. Download and Installation
Get it here. You can choose between a package with installer or just the executable in a zip file. Extract the zip file to any location you want and start it from there

Note:
If you use Windows98 you may receive the error message oleacc.dll not found. This dll is part of the MS System Updates for Win98.
2. Preferences
After eMule has started go to Preferences. The following will only describe some important settings. If you want more details on the settings read the entire FAQ

- General

Nick.
Please enter a nick name. This http://emule-project.net nick is boring.
Associate eMule with the eDonkey web link format
For eMule to accept this special web link format press the [image] -button. If this button is greyed out, eMule is already associated.
- Connection
The Connection tab is by far the most important Preferences dialogue. Please take the time to thoroughly read this explanation
Wizard
For a quick setup you can also use the Wizard. It will give you good values to start with.
o | Operating System
It is recommended to use a newer operating system like Windows 200 or XP as they handle multiple connections far better than Windows 9x/ME
o | Concurrent Downloads
This setting will affect the max allowed number of Sources per file and not the number of files you can download. If you have many files in the transfer list, the lower the max number of sources per file should be. Choose how many files you probably will have in your list.
Note:
Do not add too many files to your Downloads list. The Found Sources value in the Statistic tab should not be higher than ~3000. Too many sources will only clog your connection with permanent source asking. When you expand a download in the Transfer tab and see many (Too many connections) in front of sources, you have too many sources for your connection type to handle. Reduce your Hard Limit value.
o | Connection Type
Choose your connection from the list. It is important to choose the correct speed for your connection. If it is not listed choose Custom and enter the values in the True Bandwidth boxes. Mind the difference between kiloBits/s [kb/s] and kiloBytes/s [kB/s]. One Byte equals 8 Bits.
Press Apply and you are done with the Connection setup.

- Directories
In the Directories Preferences you can specify the folder where completed files are stored (Incoming Files) and the path to the unfinished files (Temporary Files).
Marked folders in Shared Directories are released to the network. If you want to share multiple subdirectories use the CTRL key and check the parent folder.

Note:
If you are switching from eDonkey2000 to eMule simply point to the same Incoming and Temporary folders you used in eDonkey2000. The files will be automatically added after eMule is restarted.
3. | Servers
Servers are needed to permit you accessing the network. On the first start it is important to get a recent server list.
The easiest way to update your server list is to use the Update server.met from URL box in eMule. See here for more details on updating server lists.
There are many websites who provide good server.met files but for a quick start copy this URL
http://ocbmaurice.dyns.net/pl/slist.pl?download/server-good.met

to your clipboard and paste it in the update box then press the Update-button. Thanks to Maurice for providing this server list service.
How many servers have been added to your list is displayed in the Servers tab in the Log window.
4. | Connecting to a Server
When you have updated the server list press the [image] Connect Button in the upper left corner.
Once successfully connected to a server, the status bar on bottom end of eMule should look like this:

Important:
denotes a high ID. Everything is fine.
if you get this icon on every connection attempt you have low ID and should read about ID, Firewalls, and Routers in the FAQ
5. | That's it!

Now you can start downloading either through searching directly in eMule (use Global if you miss results), through searching with web based search engines or from one of the various supporting sites.
6. | Additional things to know
o | eMule's icons explained
o | Colors of the download bar
o | QR - Queue Ranking
o | If you want to have a good download speed add files with many sources. Files having below 100 sources can be considered rare and may take quite some time to download. Have patience!
o | eMule gets faster the longer it runs. Do not expect high download rates right after start up.
o | This network is best suited for big files. Please do not share large collections of individual small files. This will put unnecessary load on the servers.
o | You will be rewarded for sharing
Have fun with eMule!

03.04.2004 8:28


232

 Network Guide
Network Guide
From release v.42.1 on eMule features two different networks – the classic server based eD2k network and a completely new server less topology based on Kademlia.
In essence both networks have the same functions. They both provide a separate means of finding other users or files you are wanting to download.

Basics
File identification
All files are given a hash value. This hash is a combination of numbers and letters to uniquely identify the file. Numerous filenames may be associated with a file, but this does not change anything about file’s hash value. This allows each user to find all sources to a particular file no matter what file name each user has given the file.
In addition, the files are broken into 9.28 MB of parts of data. Each part is also given a hash value. For example a 600 MB file would contain 65 parts. Each part is then given a hash value. Then the file hash is created from these part hashes to be used in the networks.

Identifying other clients
Like the file hash, each user in the network gets a unique and permanent user hash. This user identification is highly secured by a public / private key handshake to prevent misuse.

Downloading Data
It is important to understand that the actual downloading in eMule is not affected by the choice of the network. The network topology is only related to searching for files and finding clients that are sources to a file.
Once a source has been found, your client contacts it. The source then reserves a queue place for that specific download. When you reach the first queue place after a certain waiting time you are entitled for receiving data.

Classic server based eD2k
Connecting to the network
The key to this network is the eD2k server. Each client must to be connected to a server to enter the network.
When connecting your client to a server, the server checks to see if other clients can freely connect to your client. If yes, the server assigns your client a so-called high ID. If communication is blocked, the server assigns your client a low ID.
After the ID is assigned, eMule will send a list of all shared files to the server. The server adds the filenames and hash values you sent to its database.

Searching for files
Once connected to the network, the client can search for keywords in filenames. A search can either be local or global. If it’s a local search (searches only the server you are connected to), searches are quicker but will have fewer results. If the search is a global search (searches all the servers within the network), it will take longer but have more results. Each server looks up the keyword in its local database and returns any file names (with the hash value) that matches the keyword.

Finding sources for files
Downloads can be added by eMule’s search function or a special eD2k link format offered on many websites.
Once they are in the Download list, eMule first queries the local (connected) server then all other servers in the network for sources to that particular download. The server looks up the file’s hash value in its database and returns the clients it knows for having it.
Sources are other clients who have at least downloaded one entire part (9.28 MB) of the file matching the hash.

Kademlia serverless network
Connecting to the network
The only thing needed to connect to this network is the IP and port of any eMule client already connected. This is called a Boot Strap.
Once a client is in the network, the client then requests for other clients to determine if it can be contacted freely. This process is very similar to the HighID/LowID check on the servers. If you can be freely contacted, you are assigned an ID (similar to a HighID) and given an open status. If you are not freely contacted, you are given a firewalled status. From version v.44a on, the Kademlia network supports a Buddy for firewalled users. Buddies are other Kademlia clients who have status open and work as a relay for connections, that the firewalled user cannot manage.

Searching in Kademlia
In this network it does not matter what you search for. Be it a search for filenames, for sources of a download or for other users, all work pretty much the same.
There are no servers to keep track of clients and the files they share so it has to be done by each participating client in the network – in essence, every client is also a small server.
Since every client is identified by a unique hash value, the idea of Kademlia is to associate a certain “responsibility” based on this hash. Each client in the Kademlia network works as a server for certain keywords or sources. The client’s hash determines the specific keywords or sources.
So the goal of any kind of search is to find those clients that have the responsibility for the current search topic. This is accomplished by a complex calculation of the possible distance to the target client by asking other clients for the shortest route to it.

Summary
Both networks have a totally different concept of achieving the same: Searching for files and finding sources to a file. The main goal of the Kademlia network is to be independent of servers and improve scalability. Servers can only handle a certain amount of users and should a large server go down the network is severely handicapped.
Kademlia is self-organising and tunes itself for best possible performance depending on the number of users and their connection qualities. Therefore, it is more resistance to a large-scale network loss.

Last Update: 2004-09-12, Monk
12.09.2004 8:00


99

 Tools
eMule Tools & Utilities:
MetMedic | Tool to edit .met files and recover lost downloads
DonkeyDoctor | Recovery tool. Easy to use.
eD2k RecoverMET | Commandline tool for part.met recovery. (eD2k Link)
eD2k Link Killer | Cleans broken eD2k link associations from the registry.

Misc Tools & Utilities:
Connection test | Test script by TheDonkeyNetwork to check if client port is open
Online Signature | Modify images with data from onlinesig.dat. See Online Signature
New Online Signature | German site developing the Online Signature app
AC-Plug | Redails on connection loss
VideoLAN Client | Alternative way of previewing multimedia files. See Preferences -> Directories
RASPPPOE | PPPOE driver for dial up DSL by Robert Schlabbach
WinSockFix | Tool for repairing the Windows Winsocks.
LSPFix | Tool for repairing the Windows Winsocks.

If you know a good eMule related tool send mail to Monk@emule-project.net and I will add it to this page.

Last update on: 2004-03-20 by Monk

02.05.2004 15:21